#ifndef Model_H
#define Model_H


#include <ctime>
#include <windows.h>
#include "Thread.h"
#include "View.h"
#include "RandomListGenerator.h"
#include "SyncronousAutomaton.h"
#include "TowerNeighborhood.h"
#include "AlfilNeighborhood.h"
#include "QueenNeighborhood.h"
#include  "valores.h"
// Global Mutex Object
CMutex g_m;
//CRITICAL_SECTION m_cs;

class Model : public CThread{

	View* view;
	SyncronousAutomaton<Bicho> *automaton2d;
	// con este objeto generas una lista de valores al azar no repetidos para llamar a
	// las casillas de manera azaroza
	RandomListGenerator<(xmax*ymax)> randomList;
	/// este valor te permite llamar a la casilla analizada en el momento desde
	///cualquier funcion
	int index;
	/// este valore se necestia en la funcion copiaCasilla
	int copia;
	// valor semilla para el generador de numeros al azar
	time_t timer;
	// este es el valor que usas para guardar un numero al azar en todas las funciones
	int randomNumber;
	
public:
	
	void ThreadCtor(View* v){
		view = v;
	
		//printf("model  constructor----------------------------- \n");
		
		automaton2d = new SyncronousAutomaton<Bicho>
		(&statesMatrix[0][0], &statesMatrixnt1[0][0], dimSizes2D, dimencions2D); 
		automaton2d->setNeighborhood(new QueenNeighborhood(1));/*automaton2d->setNeighborhood(new TowerNeighborhood(1));automaton2d->setNeighborhood(new AlfilNeighborhood(1));*/
		automaton2d->setNormalizedDimencion(0);
		automaton2d->setNormalizedDimencion(1);
		automaton2d->iterateOverTheSatesArray();	

		int pos = 54;
		(*(automaton2d->graph[pos].centerCell)).type = 2;
		(*(automaton2d->graph[pos].centerCell)).direccion = 5;
		(*(automaton2d->graph[pos].centerCell)).derecho = false;
		(*(automaton2d->graph[pos].centerCell)).juvenil = false;
		(*(automaton2d->graph[pos].centerCell)).banderaJuvenil = 0;
		(*(automaton2d->graph[pos].centerCell)).banderaApareandose = 0;
		(*(automaton2d->graph[pos].centerCell)).alelo1 = 2;
		(*(automaton2d->graph[pos].centerCell)).alelo2 = 1;
		(*(automaton2d->graph[pos].centerCell)).calculaVista();
		
		//(*(automaton2d->neighbors[(*(automaton2d->graph[pos].centerCell)).frente + automaton2d->graph[pos].beginNeighbor])).type = 1;
		//(*(automaton2d->neighbors[(*(automaton2d->graph[pos].centerCell)).frenteDerecha + automaton2d->graph[pos].beginNeighbor])).type = 1;
		//(*(automaton2d->neighbors[(*(automaton2d->graph[pos].centerCell)).frenteIzquierda + automaton2d->graph[pos].beginNeighbor])).type = 1;
		
		/*
		//atras
		pos = 44;
		(*(automaton2d->graph[pos].centerCell)).type = 2;
		(*(automaton2d->graph[pos].centerCell)).direccion = 8;
		(*(automaton2d->graph[pos].centerCell)).derecho = false;
		(*(automaton2d->graph[pos].centerCell)).juvenil = false;
		(*(automaton2d->graph[pos].centerCell)).banderaJuvenil = 0;
		(*(automaton2d->graph[pos].centerCell)).banderaApareandose = 0;
		(*(automaton2d->graph[pos].centerCell)).comiendo = false;
		(*(automaton2d->graph[pos].centerCell)).banderaComiendo = 0;
		(*(automaton2d->graph[pos].centerCell)).alelo1 = 2;
		(*(automaton2d->graph[pos].centerCell)).alelo2 = 2;
		/*
		//atrasDerecha
		pos = 45;
		(*(automaton2d->graph[pos].centerCell)).type = 2;
		(*(automaton2d->graph[pos].centerCell)).direccion = 8;
		(*(automaton2d->graph[pos].centerCell)).derecho = false;
		(*(automaton2d->graph[pos].centerCell)).juvenil = false;
		(*(automaton2d->graph[pos].centerCell)).banderaJuvenil = 0;
		(*(automaton2d->graph[pos].centerCell)).banderaApareandose = 0;
		(*(automaton2d->graph[pos].centerCell)).comiendo = true;
		(*(automaton2d->graph[pos].centerCell)).banderaComiendo = -20;
		
		//atrasIzquierda
		pos = 43;
		(*(automaton2d->graph[pos].centerCell)).type = 2;
		(*(automaton2d->graph[pos].centerCell)).direccion = 8;
		(*(automaton2d->graph[pos].centerCell)).derecho = false;
		(*(automaton2d->graph[pos].centerCell)).juvenil = false;
		(*(automaton2d->graph[pos].centerCell)).banderaJuvenil = 0;
		(*(automaton2d->graph[pos].centerCell)).banderaApareandose = 0;
		(*(automaton2d->graph[pos].centerCell)).comiendo = true;
		(*(automaton2d->graph[pos].centerCell)).banderaComiendo = -20;
		
		//derecha
		pos = 55;
		(*(automaton2d->graph[pos].centerCell)).type = 3;
		(*(automaton2d->graph[pos].centerCell)).direccion = 2;
		(*(automaton2d->graph[pos].centerCell)).derecho = false;
		(*(automaton2d->graph[pos].centerCell)).juvenil = false;
		(*(automaton2d->graph[pos].centerCell)).banderaJuvenil = 0;
		(*(automaton2d->graph[pos].centerCell)).banderaApareandose = 0;
		(*(automaton2d->graph[pos].centerCell)).comiendo = true;
		(*(automaton2d->graph[pos].centerCell)).banderaComiendo = -20;
		
		//izquierda
		pos = 53;
		(*(automaton2d->graph[pos].centerCell)).type = 3;
		(*(automaton2d->graph[pos].centerCell)).direccion = 2;
		(*(automaton2d->graph[pos].centerCell)).derecho = false;
		(*(automaton2d->graph[pos].centerCell)).juvenil = false;
		(*(automaton2d->graph[pos].centerCell)).banderaJuvenil = 0;
		(*(automaton2d->graph[pos].centerCell)).banderaApareandose = 0;
		(*(automaton2d->graph[pos].centerCell)).comiendo = true;
		(*(automaton2d->graph[pos].centerCell)).banderaComiendo = -20;
		
		//frenteDerecha
		pos = 65;
		(*(automaton2d->graph[pos].centerCell)).type = 3;
		(*(automaton2d->graph[pos].centerCell)).direccion = 2;
		(*(automaton2d->graph[pos].centerCell)).derecho = false;
		(*(automaton2d->graph[pos].centerCell)).juvenil = false;
		(*(automaton2d->graph[pos].centerCell)).banderaJuvenil = 0;
		(*(automaton2d->graph[pos].centerCell)).banderaApareandose = 0;
		(*(automaton2d->graph[pos].centerCell)).comiendo = true;
		(*(automaton2d->graph[pos].centerCell)).banderaComiendo = -20;
		
		//frenteIzquierda
		pos = 63;
		(*(automaton2d->graph[pos].centerCell)).type = 3;
		(*(automaton2d->graph[pos].centerCell)).direccion = 2;
		(*(automaton2d->graph[pos].centerCell)).derecho = false;
		(*(automaton2d->graph[pos].centerCell)).juvenil = false;
		(*(automaton2d->graph[pos].centerCell)).banderaJuvenil = 0;
		(*(automaton2d->graph[pos].centerCell)).banderaApareandose = 0;
		(*(automaton2d->graph[pos].centerCell)).comiendo = true;
		(*(automaton2d->graph[pos].centerCell)).banderaComiendo = -20;
		
		//frente
		pos = 64;
		(*(automaton2d->graph[pos].centerCell)).type = 3;
		(*(automaton2d->graph[pos].centerCell)).direccion = 2;
		(*(automaton2d->graph[pos].centerCell)).derecho = false;
		(*(automaton2d->graph[pos].centerCell)).juvenil = false;
		(*(automaton2d->graph[pos].centerCell)).banderaJuvenil = 0;
		(*(automaton2d->graph[pos].centerCell)).banderaApareandose = 0;
		(*(automaton2d->graph[pos].centerCell)).comiendo = true;
		(*(automaton2d->graph[pos].centerCell)).banderaComiendo = -20;
		*/
		/*
		//estos los pongo para analizar la diagonal
		pos = 99;
		(*(automaton2d->graph[pos].centerCell)).type = 3;
		(*(automaton2d->graph[pos].centerCell)).direccion = 1;
		(*(automaton2d->graph[pos].centerCell)).derecho = false;
		(*(automaton2d->graph[pos].centerCell)).juvenil = false;
		(*(automaton2d->graph[pos].centerCell)).banderaJuvenil = 0;
		(*(automaton2d->graph[pos].centerCell)).banderaApareandose = 0;
		(*(automaton2d->graph[pos].centerCell)).comiendo = false;
		(*(automaton2d->graph[pos].centerCell)).banderaComiendo = 0;
		*/
	}
	~Model(){}
	/*En este metodo se copia los valores de la casilla analizada en este momento 
	(*(automaton2d->graph[index].centerCell)) a la casilla dada por la direccion
	recordemos que las direcciones son:
	
	//					 frenteIzquierda  frente  frenteDerecha    
	//								    \    |   /
	//				           izquierda -centro- derecha
	//								    /    |	 \
	//				      atrasIzquierda   atras  atrasDerecha
	 y en este caso el metodo resive un numero segun a que casilla se deve de copiar
	 todo, 1 = frente y se avanza contrario a las manesillas del reloj hasta 
	 8 = frente derecha
	*/
	void copiaCasilla(int pos){
		//primero determina a que casilla vas a copiar todo
		if(pos == 1)
			copia = (*(automaton2d->graph[index].centerCell)).frente;
		else if(pos == 2)
			copia = (*(automaton2d->graph[index].centerCell)).frenteIzquierda;
		else if(pos == 3)
			copia = (*(automaton2d->graph[index].centerCell)).izquierda;
		else if(pos == 4)
			copia = (*(automaton2d->graph[index].centerCell)).atrasIzquierda;
		else if(pos == 5)
			copia = (*(automaton2d->graph[index].centerCell)).atras;
		else if(pos == 6)
			copia = (*(automaton2d->graph[index].centerCell)).atrasDerecha;
		else if(pos == 7)
			copia = (*(automaton2d->graph[index].centerCell)).derecha;
		else 
			copia = (*(automaton2d->graph[index].centerCell)).frenteDerecha;
		
		(*(automaton2d->neighbors[copia + automaton2d->graph[index].beginNeighbor])).actuaste = (*(automaton2d->graph[index].centerCell)).actuaste;
		(*(automaton2d->neighbors[copia + automaton2d->graph[index].beginNeighbor])).alelo1 = (*(automaton2d->graph[index].centerCell)).alelo1;
		(*(automaton2d->neighbors[copia + automaton2d->graph[index].beginNeighbor])).alelo2 = (*(automaton2d->graph[index].centerCell)).alelo2;
		(*(automaton2d->neighbors[copia + automaton2d->graph[index].beginNeighbor])).apareandose = (*(automaton2d->graph[index].centerCell)).apareandose;
		(*(automaton2d->neighbors[copia + automaton2d->graph[index].beginNeighbor])).banderaApareandose = (*(automaton2d->graph[index].centerCell)).banderaApareandose;
		(*(automaton2d->neighbors[copia + automaton2d->graph[index].beginNeighbor])).banderaComiendo = (*(automaton2d->graph[index].centerCell)).banderaComiendo;
		(*(automaton2d->neighbors[copia + automaton2d->graph[index].beginNeighbor])).banderaJuvenil = (*(automaton2d->graph[index].centerCell)).banderaJuvenil;
		(*(automaton2d->neighbors[copia + automaton2d->graph[index].beginNeighbor])).comiendo = (*(automaton2d->graph[index].centerCell)).comiendo;
		(*(automaton2d->neighbors[copia + automaton2d->graph[index].beginNeighbor])).derecho = (*(automaton2d->graph[index].centerCell)).derecho;
		(*(automaton2d->neighbors[copia + automaton2d->graph[index].beginNeighbor])).direccion = (*(automaton2d->graph[index].centerCell)).direccion;
		(*(automaton2d->neighbors[copia + automaton2d->graph[index].beginNeighbor])).juvenil = (*(automaton2d->graph[index].centerCell)).juvenil;
		(*(automaton2d->neighbors[copia + automaton2d->graph[index].beginNeighbor])).lagartijaVerde = (*(automaton2d->graph[index].centerCell)).lagartijaVerde;
		(*(automaton2d->neighbors[copia + automaton2d->graph[index].beginNeighbor])).type = (*(automaton2d->graph[index].centerCell)).type;
		
	}//fin copiaCasilla()
	/*esta funcion se usa para remover todos los valores al abandonar una casilla*/
	void limpiaCasilla(){
		(*(automaton2d->neighbors[copia + automaton2d->graph[index].beginNeighbor])).actuaste = false;
		(*(automaton2d->neighbors[copia + automaton2d->graph[index].beginNeighbor])).alelo1 = 0;
		(*(automaton2d->neighbors[copia + automaton2d->graph[index].beginNeighbor])).alelo2 = 0;
		(*(automaton2d->neighbors[copia + automaton2d->graph[index].beginNeighbor])).apareandose = false;
		(*(automaton2d->graph[index].centerCell)).banderaApareandose = 0;
		(*(automaton2d->graph[index].centerCell)).banderaComiendo = 0;
		(*(automaton2d->graph[index].centerCell)).banderaJuvenil = 0;
		(*(automaton2d->graph[index].centerCell)).comiendo = false;
		(*(automaton2d->graph[index].centerCell)).derecho = true;
		(*(automaton2d->graph[index].centerCell)).direccion = 0;
		(*(automaton2d->graph[index].centerCell)).juvenil = false;
		(*(automaton2d->graph[index].centerCell)).lagartijaVerde = false;
		(*(automaton2d->graph[index].centerCell)).type = 0;
	}
	/* esta funcion checa si se tiene un gato en el vecindario (visible) de la casilla
	dada por el index*/
	bool checaGato(){
		//checa gato en diversas casillas con respecto a la casilla del centro y su direccion
		// respectiva (calculo dado en la funcion calculaVista() de bicho, que modifica los
		//diferentes valores de enfrente, atras, derecha.. etc)
		
		//checa enfrente
		if((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).type == 3)
			return true;
		//checa frente derecha
		else if((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha+ automaton2d->graph[index].beginNeighbor])).type == 3)
			return true;
		//checa frente izquierda
		else if((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda+ automaton2d->graph[index].beginNeighbor])).type == 3)
			return true;
		// si no viste nada
		else 
			return false;
	}//checaGato()
	/*En esta funcion tratas de escapar de algo que viste en las casillas visbles, intentando 
	por todos los medios ir a las casillas contrarias*/
	void huye(){
		//si la casilla de atras esta vacia muevete a ella
		if((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).atras + automaton2d->graph[index].beginNeighbor])).type == 0){
			//copia tus valores a la nueva casilla
			if(((*(automaton2d->graph[index].centerCell)).direccion + 4)<=8)
				(*(automaton2d->graph[index].centerCell)).direccion = (*(automaton2d->graph[index].centerCell)).direccion + 4;	
			else
				(*(automaton2d->graph[index].centerCell)).direccion = ((*(automaton2d->graph[index].centerCell)).direccion + 4) - 8;	
			// este if else es para animar un poco la imagen
			if((*(automaton2d->graph[index].centerCell)).derecho == true)
				(*(automaton2d->graph[index].centerCell)).derecho = false;
			else
				(*(automaton2d->graph[index].centerCell)).derecho = true;
			copiaCasilla(5);
			//despues limpia la casilla que avandonas
			limpiaCasilla();
			// sal de aqui esto evita moverte a otra casilla desocupada
			goto finFuncion;
		}//fin if casilla atras vacia
		//si la casilla de atrasDerecha esta vacia muevete a ella
		else if((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).atrasDerecha + automaton2d->graph[index].beginNeighbor])).type == 0){
			//copia tus valores a la nueva casilla
			if(((*(automaton2d->graph[index].centerCell)).direccion + 5)<=8)
				(*(automaton2d->graph[index].centerCell)).direccion = (*(automaton2d->graph[index].centerCell)).direccion + 5;	
			else
				(*(automaton2d->graph[index].centerCell)).direccion = ((*(automaton2d->graph[index].centerCell)).direccion + 5) - 8;	
			// este if else es para animar un poco la imagen
			if((*(automaton2d->graph[index].centerCell)).derecho == true)
				(*(automaton2d->graph[index].centerCell)).derecho = false;
			else
				(*(automaton2d->graph[index].centerCell)).derecho = true;
			copiaCasilla(6);
			//despues limpia la casilla que avandonas
			limpiaCasilla();
			// sal de aqui esto evita moverte a otra casilla desocupada
			goto finFuncion;
		}//fin else if casilla atrasDerecha vacia 
		//si la casilla de atrasIzquierda esta vacia muevete a ella
		else if((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).atrasIzquierda + automaton2d->graph[index].beginNeighbor])).type == 0){
			//copia tus valores a la nueva casilla
			if(((*(automaton2d->graph[index].centerCell)).direccion + 3)<=8)
				(*(automaton2d->graph[index].centerCell)).direccion = (*(automaton2d->graph[index].centerCell)).direccion + 3;	
			else
				(*(automaton2d->graph[index].centerCell)).direccion = ((*(automaton2d->graph[index].centerCell)).direccion + 3) - 8;	
			// este if else es para animar un poco la imagen
			if((*(automaton2d->graph[index].centerCell)).derecho == true)
				(*(automaton2d->graph[index].centerCell)).derecho = false;
			else
				(*(automaton2d->graph[index].centerCell)).derecho = true;
			copiaCasilla(4);
			//despues limpia la casilla que avandonas
			limpiaCasilla();
			// sal de aqui esto evita moverte a otra casilla desocupada
			goto finFuncion;
		}//fin else if casilla atrasIzquierda vacia 
		//si la casilla de derecha esta vacia muevete a ella
		else if((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).derecha + automaton2d->graph[index].beginNeighbor])).type == 0){
			//copia tus valores a la nueva casilla
			// este if else es solamente para que al moverte se vea mejor el cambio de direccion
			if(((*(automaton2d->graph[index].centerCell)).direccion + 6)<=8)
				(*(automaton2d->graph[index].centerCell)).direccion = (*(automaton2d->graph[index].centerCell)).direccion + 6;	
			else
				(*(automaton2d->graph[index].centerCell)).direccion = ((*(automaton2d->graph[index].centerCell)).direccion + 6) - 8;	
			// este if else es para animar un poco la imagen
			if((*(automaton2d->graph[index].centerCell)).derecho == true)
				(*(automaton2d->graph[index].centerCell)).derecho = false;
			else
				(*(automaton2d->graph[index].centerCell)).derecho = true;
			copiaCasilla(7);
			//despues limpia la casilla que avandonas
			limpiaCasilla();
			// sal de aqui esto evita moverte a otra casilla desocupada
			goto finFuncion;
		}// else if casilla derecha vacia
		//si la casilla de izquierda esta vacia muevete a ella
		else if((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).izquierda + automaton2d->graph[index].beginNeighbor])).type == 0){
			//copia tus valores a la nueva casilla
			// este if else es solamente para que al moverte se vea mejor el cambio de direccion
			if(((*(automaton2d->graph[index].centerCell)).direccion + 2)<=8)
				(*(automaton2d->graph[index].centerCell)).direccion = (*(automaton2d->graph[index].centerCell)).direccion + 2;	
			else
				(*(automaton2d->graph[index].centerCell)).direccion = ((*(automaton2d->graph[index].centerCell)).direccion + 2) - 8;	
			// este if else es para animar un poco la imagen
			if((*(automaton2d->graph[index].centerCell)).derecho == true)
				(*(automaton2d->graph[index].centerCell)).derecho = false;
			else
				(*(automaton2d->graph[index].centerCell)).derecho = true;
			copiaCasilla(3);
			//despues limpia la casilla que avandonas
			limpiaCasilla();
			// sal de aqui esto evita moverte a otra casilla desocupada
			goto finFuncion;
		}// fin else if casilla izquierda vacia
		// if casilla frenteDerecha esta vacia
		else if((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).type == 0){
			//copia tus valores a la nueva casilla
			// este if else es solamente para que al moverte se vea mejor el cambio de direccion
			if(((*(automaton2d->graph[index].centerCell)).direccion + 7)<=8)
				(*(automaton2d->graph[index].centerCell)).direccion = (*(automaton2d->graph[index].centerCell)).direccion + 7;	
			else
				(*(automaton2d->graph[index].centerCell)).direccion = ((*(automaton2d->graph[index].centerCell)).direccion + 7) - 8;	
			// este if else es para animar un poco la imagen
			if((*(automaton2d->graph[index].centerCell)).derecho == true)
				(*(automaton2d->graph[index].centerCell)).derecho = false;
			else
				(*(automaton2d->graph[index].centerCell)).derecho = true;
			copiaCasilla(8);
			//despues limpia la casilla que avandonas
			limpiaCasilla();
			// sal de aqui esto evita moverte a otra casilla desocupada
			goto finFuncion;
		}//fin else if frenteDerecha	
		// if casilla frenteIzquierda esta vacia
		else if((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).type == 0){
			//copia tus valores a la nueva casilla
			// este if else es solamente para que al moverte se vea mejor el cambio de direccion
			if(((*(automaton2d->graph[index].centerCell)).direccion + 1)<=8)
				(*(automaton2d->graph[index].centerCell)).direccion = (*(automaton2d->graph[index].centerCell)).direccion + 1;	
			else 
				(*(automaton2d->graph[index].centerCell)).direccion = ((*(automaton2d->graph[index].centerCell)).direccion + 1) - 8;	
			// este if else es para animar un poco la imagen
			if((*(automaton2d->graph[index].centerCell)).derecho == true)
				(*(automaton2d->graph[index].centerCell)).derecho = false;
			else
				(*(automaton2d->graph[index].centerCell)).derecho = true;
			copiaCasilla(2);
			//despues limpia la casilla que avandonas
			limpiaCasilla();
			// sal de aqui esto evita moverte a otra casilla desocupada
			goto finFuncion;
		}//fin else if casilla frente izquierda
		// if casilla frente esta vacia
		else if((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).type == 0){
			//copia tus valores a la nueva casilla
			// este if else es para animar un poco la imagen
			if((*(automaton2d->graph[index].centerCell)).derecho == true)
				(*(automaton2d->graph[index].centerCell)).derecho = false;
			else
				(*(automaton2d->graph[index].centerCell)).derecho = true;
			copiaCasilla(1);
			//despues limpia la casilla que avandonas
			limpiaCasilla();
			// sal de aqui esto evita moverte a otra casilla desocupada
			goto finFuncion;
		}// fin else if casilla vaica enfrente
		// por ultimo si no tienes casillas vacias
		else{
			// como no se tiene a donde huir solo cambias de direccion y resas
			if((*(automaton2d->graph[index].centerCell)).derecho == true)
				(*(automaton2d->graph[index].centerCell)).derecho = false;
			else
				(*(automaton2d->graph[index].centerCell)).derecho = true;
			//y su direccion
			randomNumber = (rand() % 8) + 1;
			(*(automaton2d->graph[index].centerCell)).direccion = randomNumber;					
		} // fin else
		finFuncion:
			;	
	}// huye()
	/*esta funcion da true si se encuentra una casilla vacia dentro de las visibles*/
	bool checaEspacioVacio(){
		if((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).type == 0) 
			return true;
		else if((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).type == 0) 
			return true;
		else if((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).type == 0) 
			return true;
		else
			return false;
	}//checaEspacioVacio()
	/* esta funcion checa a ver si alguna de las casillas visibles tiene una lagartija, 
		que no sea juevenil y no se este apareando*/								
	bool checaPareja(){
		// si alguna casilla tiene una lagartija no apareandose y no juvenil
		if(((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).type == 1) && ((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).juvenil == false) && ((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).apareandose == false) )
			return true;
		else if(((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).type == 1) && ((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).juvenil == false) && ((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).apareandose == false) )
			return true;
		else if(((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).type == 1) && ((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).juvenil == false) && ((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).apareandose == false) )
			return true;
		else if(((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).type == 2) && ((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).juvenil == false) && ((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).apareandose == false) )
			return true;
		else if(((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).type == 2) && ((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).juvenil == false) && ((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).apareandose == false) )
			return true;
		else if(((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).type == 2) && ((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).juvenil == false) && ((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).apareandose == false) ) 
			return true;
		else 
			return false;
	}// fin checaPareja()
	/*En esta funcion haces todo lo relacionado con aparearte ya que viste esa posivilidad en
	alguna de las casilla visibles, aunque podria no lograrse si no se tiene donde poner un
	huevo en cuyo caso solo cambias de direccion*/
	void apareate(){
		// primero checa que se tenga un espacio vacio si no no puedes aparearte
		if(checaEspacioVacio()){
			printf("se tiene un espacio vacio\n");
			// revisa las casillas una por una
			// primero revisa si la casilla del frente tiene una lagartija disponible
			if( (((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).type == 1) || ((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).type == 2) )
			&& ((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).juvenil == false) 
			&& ((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).apareandose == false) 
			){
				printf("me apareo con la de enfrente\n");
				// luego checa si alguna casilla de los lados esta vacia para poner un huevo

				// checando casilla enfrente derecha vacia y apareandome con casilla de enfrente
				if((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).type == 0){
					printf("la casilla de .frenteDerecha esta vacia y pondre huevo\n");
					// marco que me estoy apareando
					(*(automaton2d->graph[index].centerCell)).apareandose = true;
					// marco a la lagartija con la que me estoy aparenando
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).apareandose = true;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).actuaste = true;
					// y tambien muevo la imagen de la otra lagartija para que se vea que nos miramos (mientras sex)
					if(((*(automaton2d->graph[index].centerCell)).direccion + 4)<=8)
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).direccion = (*(automaton2d->graph[index].centerCell)).direccion + 4;	
					else
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).direccion = ((*(automaton2d->graph[index].centerCell)).direccion + 4) - 8;	
					// creo el huevo
					/************MENDEL***************************************************************************/
					printf("yo type = %d\n",(*(automaton2d->graph[index].centerCell)).type);
					printf("alelo 1 = %d\n",(*(automaton2d->graph[index].centerCell)).alelo1);
					printf("alelo 2 = %d\n",(*(automaton2d->graph[index].centerCell)).alelo2);
					printf("mi pareja type = %d\n",(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).type);
					printf("alelo 1 = %d\n",(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).alelo1);
					printf("alelo 2 = %d\n",(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).alelo2);
					
					// primero calcula cual de los alelos pasas
					randomNumber = rand()%2;
					if(randomNumber == 0)
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).alelo1 = (*(automaton2d->graph[index].centerCell)).alelo1;
					else
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).alelo1 = (*(automaton2d->graph[index].centerCell)).alelo2;
					// luego calcula cual alelo pasa con quien te apareas
					randomNumber = rand()%2;
					if(randomNumber == 0)
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).alelo2 = (*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).alelo1;
					else
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).alelo2 = (*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).alelo2;
					// y por ulimo defines el tipo que corresponde segun los alelos que tengas y cual es 
					//dominante y/o resesivo
					
					// si tienes el gen dominate tu tipo es dominante
					if((dominante == (*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).alelo1)
					 ||(dominante == (*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).alelo2))
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).type = dominante;
					// si no tienes el gen dominante eres de tipo resesivo
					else
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).type = resesivo;
					/**********FIN**MENDEL***************************************************************************/
					printf("el huevo creado type = %d\n",(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).type);
					printf("alelo 1 = %d\n",(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).alelo1);
					printf("alelo 2 = %d\n",(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).alelo2);
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).juvenil = true;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).banderaJuvenil = 0;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).actuaste = true;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).apareandose = false;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).banderaApareandose = 0;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).comiendo = false;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).banderaComiendo = 0;
					goto finAperandose;
				}// fin de if checando casilla enfrente derecha vacia 
				// checando casilla enfrente izquierda vacia y apareandome con casilla de enfrente
				else if((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).type == 0){
					printf("la casilla de .frenteIzquierda esta vacia y pondre huevo");
					// marco que me estoy apareando
					(*(automaton2d->graph[index].centerCell)).apareandose = true;
					// marco a la lagartija con la que me estoy aparenando
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).apareandose = true;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).actuaste = true;
					// y tambien muevo la imagen para que se vea que nos miramos (mientras sex)
					if(((*(automaton2d->graph[index].centerCell)).direccion + 4)<=8)
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).direccion = (*(automaton2d->graph[index].centerCell)).direccion + 4;	
					else
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).direccion = ((*(automaton2d->graph[index].centerCell)).direccion + 4) - 8;	
					// creo el huevo
					/************MENDEL***************************************************************************/
					// primero calcula cual de los alelos pasas
					printf("yo type = %d\n",(*(automaton2d->graph[index].centerCell)).type);
					printf("alelo 1 = %d\n",(*(automaton2d->graph[index].centerCell)).alelo1);
					printf("alelo 2 = %d\n",(*(automaton2d->graph[index].centerCell)).alelo2);
					printf("mi pareja type = %d\n",(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).type);
					printf("alelo 1 = %d\n",(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).alelo1);
					printf("alelo 2 = %d\n",(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).alelo2);
					
					randomNumber = rand()%2;
					if(randomNumber == 0)
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).alelo1 = (*(automaton2d->graph[index].centerCell)).alelo1;
					else
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).alelo1 = (*(automaton2d->graph[index].centerCell)).alelo2;
					// luego calcula cual alelo pasa con quien te apareas
					randomNumber = rand()%2;
					if(randomNumber == 0)
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).alelo2 = (*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).alelo1;
					else
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).alelo2 = (*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).alelo2;
					// y por ulimo defines el tipo que corresponde segun los alelos que tengas y cual es 
					//dominante y/o resesivo
					
					// si tienes el gen dominate tu tipo es dominante
					if((dominante == (*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).alelo1)
						||(dominante == (*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).alelo2))
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).type = dominante;
					// si no tienes el gen dominante eres de tipo resesivo
					else
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).type = resesivo;
					/**********FIN**MENDEL***************************************************************************/
					printf("el huevo creado type = %d\n",(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).type);
					printf("alelo 1 = %d\n",(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).alelo1);
					printf("alelo 2 = %d\n",(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).alelo2);
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).juvenil = true;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).banderaJuvenil = 0;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).actuaste = true;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).apareandose = false;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).banderaApareandose = 0;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).comiendo = false;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).banderaComiendo = 0;
					goto finAperandose;
				}//fin else if checando casilla enfrente izquierda vacia 
			}//fin if apreandome con casilla de enfrente 
			// luego revisa que la casilla de enfrente dercha a ver si tiene una lagartija no juvenil y no apareandose
			else if( (((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).type == 1) || ((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).type == 2) )
			&& ((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).juvenil == false) 
			&& ((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).apareandose == false) 
			){
				printf("me apareo con la de enfrenteDerecha\n");
				// luego checa si alguna casilla de los lados esta vacia para poner un huevo
				// primero checamos la casilla de enfrente a ver si esta vacia y nos apareamos con la de frenteDerecha
				if((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).type == 0){
					printf("la casilla de enfrente esta vacia y pondre huevo");
					// marco que me estoy apareando
					(*(automaton2d->graph[index].centerCell)).apareandose = true;
					// y tambien muevo mi imagen para que se vea que nos miramos (mientras sex)
					if(((*(automaton2d->graph[index].centerCell)).direccion + 7)<=8)
						(*(automaton2d->graph[index].centerCell)).direccion = (*(automaton2d->graph[index].centerCell)).direccion + 7;	
					else
						(*(automaton2d->graph[index].centerCell)).direccion = ((*(automaton2d->graph[index].centerCell)).direccion + 7) - 8;	
					// marco a la lagartija con la que me estoy aparenando
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).apareandose = true;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).actuaste = true;
					// y tambien muevo la imagen para que se vea que nos miramos (mientras sex)
					if(((*(automaton2d->graph[index].centerCell)).direccion + 4)<=8)
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).direccion = (*(automaton2d->graph[index].centerCell)).direccion + 4;	
					else
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).direccion = ((*(automaton2d->graph[index].centerCell)).direccion + 4) - 8;	
					// creo el huevo
					/************MENDEL***************************************************************************/
					// primero calcula cual de los alelos pasas
					
					printf("yo type = %d\n",(*(automaton2d->graph[index].centerCell)).type);
					printf("alelo 1 = %d\n",(*(automaton2d->graph[index].centerCell)).alelo1);
					printf("alelo 2 = %d\n",(*(automaton2d->graph[index].centerCell)).alelo2);
					printf("mi pareja type = %d\n",(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).type);
					printf("alelo 1 = %d\n",(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).alelo1);
					printf("alelo 2 = %d\n",(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).alelo2);
					randomNumber = rand()%2;
					if(randomNumber == 0)
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).alelo1 = (*(automaton2d->graph[index].centerCell)).alelo1;
					else
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).alelo1 = (*(automaton2d->graph[index].centerCell)).alelo2;
					// luego calcula cual alelo pasa con quien te apareas
					randomNumber = rand()%2;
					if(randomNumber == 0)
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).alelo2 = (*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).alelo1;
					else
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).alelo2 = (*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).alelo2;
					// y por ulimo defines el tipo que corresponde segun los alelos que tengas y cual es 
					//dominante y/o resesivo
					
					// si tienes el gen dominate tu tipo es dominante
					if((dominante == (*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).alelo1)
						||(dominante == (*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).alelo2))
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).type = dominante;
					// si no tienes el gen dominante eres de tipo resesivo
					else
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).type = resesivo;
					/**********FIN**MENDEL***************************************************************************/
					printf("el huevo creado type = %d\n",(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).type);
					printf("alelo 1 = %d\n",(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).alelo1);
					printf("alelo 2 = %d\n",(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).alelo2);
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).juvenil = true;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).banderaJuvenil = 0;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).actuaste = true;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).apareandose = false;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).banderaApareandose = 0;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).comiendo = false;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).banderaComiendo = 0;
					goto finAperandose;
				}//fin if checamos la casilla de enfrente a ver si esta vacia
				// checo si la casilla de enfrente izquierda esta vacia para aparearme con la de enfrente derecha
				else if((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).type == 0){
					printf("la casilla de .frenteIzquierda esta vacia y pondre huevo");
					// marco que me estoy apareando
					(*(automaton2d->graph[index].centerCell)).apareandose = true;
					// y tambien muevo mi imagen para que se vea que nos miramos (mientras sex)
					if(((*(automaton2d->graph[index].centerCell)).direccion + 7)<=8)
						(*(automaton2d->graph[index].centerCell)).direccion = (*(automaton2d->graph[index].centerCell)).direccion + 7;	
					else
						(*(automaton2d->graph[index].centerCell)).direccion = ((*(automaton2d->graph[index].centerCell)).direccion + 7) - 8;	
					
					// marco a la lagartija con la que me estoy aparenando
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).apareandose = true;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).actuaste = true;
					// y tambien muevo la imagen para que se vea que nos miramos (mientras sex)
					if(((*(automaton2d->graph[index].centerCell)).direccion + 4)<=8)
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).direccion = (*(automaton2d->graph[index].centerCell)).direccion + 4;	
					else
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).direccion = ((*(automaton2d->graph[index].centerCell)).direccion + 4) - 8;	
					// creo el huevo
					/************MENDEL***************************************************************************/
					// primero calcula cual de los alelos pasas
					
					printf("yo type = %d\n",(*(automaton2d->graph[index].centerCell)).type);
					printf("alelo 1 = %d\n",(*(automaton2d->graph[index].centerCell)).alelo1);
					printf("alelo 2 = %d\n",(*(automaton2d->graph[index].centerCell)).alelo2);
					printf("mi pareja type = %d\n",(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).type);
					printf("alelo 1 = %d\n",(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).alelo1);
					printf("alelo 2 = %d\n",(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).alelo2);
					randomNumber = rand()%2;
					if(randomNumber == 0)
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).alelo1 = (*(automaton2d->graph[index].centerCell)).alelo1;
					else
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).alelo1 = (*(automaton2d->graph[index].centerCell)).alelo2;
					// luego calcula cual alelo pasa con quien te apareas
					randomNumber = rand()%2;
					if(randomNumber == 0)
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).alelo2 = (*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).alelo1;
					else
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).alelo2 = (*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).alelo2;
					// y por ulimo defines el tipo que corresponde segun los alelos que tengas y cual es 
					//dominante y/o resesivo
					
					// si tienes el gen dominate tu tipo es dominante
					if((dominante == (*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).alelo1)
						||(dominante == (*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).alelo2))
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).type = dominante;
					// si no tienes el gen dominante eres de tipo resesivo
					else
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).type = resesivo;
					/**********FIN**MENDEL***************************************************************************/
					printf("el huevo creado type = %d\n",(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).type);
					printf("alelo 1 = %d\n",(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).alelo1);
					printf("alelo 2 = %d\n",(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).alelo2);
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).juvenil = true;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).banderaJuvenil = 0;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).actuaste = true;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).apareandose = false;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).banderaApareandose = 0;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).comiendo = false;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).banderaComiendo = 0;
					goto finAperandose;
				}//fin else if si la casilla de enfrente izquierda esta vacia 
			}//casilla frente derecha revisada
			// luego revisa que la casilla de enfrente izquierda ver si tiene una lagartija no juvenil y no apareandose
			else if( (((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).type == 1) || ((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).type == 2) )
			&& ((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).juvenil == false) 
			&& ((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).apareandose == false) 
			){
				printf("me apareo con la de enfrenteIzquierda\n");
				// luego checa si alguna casilla de los lados esta vacia para poner un huevo
				// checo si la casilla de enfrente esta vacia para aparearme con la de enfrente izquierda
				if((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).type == 0){
					printf("la casilla de enfrente esta vacia y pondre huevo");
					// marco que me estoy apareando
					(*(automaton2d->graph[index].centerCell)).apareandose = true;
					// y tambien muevo mi imagen para que se vea que nos miramos (mientras sex)
					if(((*(automaton2d->graph[index].centerCell)).direccion + 1)<=8)
						(*(automaton2d->graph[index].centerCell)).direccion = (*(automaton2d->graph[index].centerCell)).direccion + 1;	
					else
						(*(automaton2d->graph[index].centerCell)).direccion = ((*(automaton2d->graph[index].centerCell)).direccion + 1) - 8;	
					// marco a la lagartija con la que me estoy aparenando
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).apareandose = true;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).actuaste = true;
					// y tambien muevo la imagen para que se vea que nos miramos (mientras sex)
					if(((*(automaton2d->graph[index].centerCell)).direccion + 4)<=8)
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).direccion = (*(automaton2d->graph[index].centerCell)).direccion + 4;	
					else
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).direccion = ((*(automaton2d->graph[index].centerCell)).direccion + 4) - 8;	
					// creo el huevo
					/************MENDEL***************************************************************************/
					// primero calcula cual de los alelos pasas
					
					printf("yo type = %d\n",(*(automaton2d->graph[index].centerCell)).type);
					printf("alelo 1 = %d\n",(*(automaton2d->graph[index].centerCell)).alelo1);
					printf("alelo 2 = %d\n",(*(automaton2d->graph[index].centerCell)).alelo2);
					printf("mi pareja type = %d\n",(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).type);
					printf("alelo 1 = %d\n",(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).alelo1);
					printf("alelo 2 = %d\n",(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).alelo2);
					randomNumber = rand()%2;
					if(randomNumber == 0)
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).alelo1 = (*(automaton2d->graph[index].centerCell)).alelo1;
					else
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).alelo1 = (*(automaton2d->graph[index].centerCell)).alelo2;
					// luego calcula cual alelo pasa con quien te apareas
					randomNumber = rand()%2;
					if(randomNumber == 0)
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).alelo2 = (*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).alelo1;
					else
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).alelo2 = (*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).alelo2;
					// y por ulimo defines el tipo que corresponde segun los alelos que tengas y cual es 
					//dominante y/o resesivo
					
					// si tienes el gen dominate tu tipo es dominante
					if((dominante == (*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).alelo1)
						||(dominante == (*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).alelo2))
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).type = dominante;
					// si no tienes el gen dominante eres de tipo resesivo
					else
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).type = resesivo;
					/**********FIN**MENDEL***************************************************************************/
					printf("el huevo creado type = %d\n",(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).type);
					printf("alelo 1 = %d\n",(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).alelo1);
					printf("alelo 2 = %d\n",(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).alelo2);
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).juvenil = true;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).banderaJuvenil = 0;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).actuaste = true;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).apareandose = false;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).banderaApareandose = 0;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).comiendo = false;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).banderaComiendo = 0;
					goto finAperandose;
				}//fin checo si la casilla de enfrente esta vacia
				// checo si la casilla de enfrente derecha esta vacia para aparearme con la de enfrente izquierda
				else if((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).type == 0){
					printf("la casilla de .frenteDerecha esta vacia y pondre huevo");
					// marco que me estoy apareando
					(*(automaton2d->graph[index].centerCell)).apareandose = true;
					// y tambien muevo mi imagen para que se vea que nos miramos (mientras sex)
					if(((*(automaton2d->graph[index].centerCell)).direccion + 1)<=8)
						(*(automaton2d->graph[index].centerCell)).direccion = (*(automaton2d->graph[index].centerCell)).direccion + 1;	
					else
						(*(automaton2d->graph[index].centerCell)).direccion = ((*(automaton2d->graph[index].centerCell)).direccion + 1) - 8;
					// marco a la lagartija con la que me estoy aparenando
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).apareandose = true;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).actuaste = true;
					// y tambien muevo la imagen para que se vea que nos miramos (mientras sex)
					if(((*(automaton2d->graph[index].centerCell)).direccion + 4)<=8)
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).direccion = (*(automaton2d->graph[index].centerCell)).direccion + 4;	
					else
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).direccion = ((*(automaton2d->graph[index].centerCell)).direccion + 4) - 8;	
					// creo el huevo
					/************MENDEL***************************************************************************/
					// primero calcula cual de los alelos pasas
					
					printf("yo type = %d\n",(*(automaton2d->graph[index].centerCell)).type);
					printf("alelo 1 = %d\n",(*(automaton2d->graph[index].centerCell)).alelo1);
					printf("alelo 2 = %d\n",(*(automaton2d->graph[index].centerCell)).alelo2);
					printf("mi pareja type = %d\n",(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).type);
					printf("alelo 1 = %d\n",(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).alelo1);
					printf("alelo 2 = %d\n",(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).alelo2);
					randomNumber = rand()%2;
					if(randomNumber == 0)
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).alelo1 = (*(automaton2d->graph[index].centerCell)).alelo1;
					else
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).alelo1 = (*(automaton2d->graph[index].centerCell)).alelo2;
					// luego calcula cual alelo pasa con quien te apareas
					randomNumber = rand()%2;
					if(randomNumber == 0)
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).alelo2 = (*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).alelo1;
					else
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).alelo2 = (*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).alelo2;
					// y por ulimo defines el tipo que corresponde segun los alelos que tengas y cual es 
					//dominante y/o resesivo
					
					// si tienes el gen dominate tu tipo es dominante
					if((dominante == (*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).alelo1)
						||(dominante == (*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).alelo2))
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).type = dominante;
					// si no tienes el gen dominante eres de tipo resesivo
					else
						(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).type = resesivo;
					/**********FIN**MENDEL***************************************************************************/
					printf("el huevo creado type = %d\n",(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).type);
					printf("alelo 1 = %d\n",(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).alelo1);
					printf("alelo 2 = %d\n",(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).alelo2);
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).juvenil = true;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).banderaJuvenil = 0;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).actuaste = true;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).apareandose = false;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).banderaApareandose = 0;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).comiendo = false;
					(*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).banderaComiendo = 0;
					goto finAperandose;
				}//fin else if checo si la casilla de enfrente derecha esta vacia 
			}//fin else if revisa que la casilla de enfrente dercha a ver si tiene una lagartija no juvenil y no apareandose 
			finAperandose:
				;
			printf(" me apareare\n");
		}//fin ifencontraste casillas vacias
		// si no se logro aparearse por falta de casillas vacias
		else{
			printf("no veo casillas vacias\n");
			//cambia de direccion
			randomNumber = (rand() % 8) + 1;
			(*(automaton2d->graph[index].centerCell)).direccion = randomNumber;
			// este if else es para animar un poco la imagen
			if((*(automaton2d->graph[index].centerCell)).derecho == true)
				(*(automaton2d->graph[index].centerCell)).derecho = false;
			else
				(*(automaton2d->graph[index].centerCell)).derecho = true;
		}//fin else no se logro encontrar casillas vacias
	}//fin apareate()
	/*En esta funcion te mueves a la/s casilla/s vacia/s que se tiene/n en las casillas
	visibles*/
	void camina(){
		//  checa alguna casilla de las casillas visibles vacia 

		// ve si la casilla de enfrente esta vacia
		if((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).type == 0){
			printf("la casilla de enfrente esta vacia\n");
			//compia todos los valores de esta casilla a la casilla vacia
			// este if else es para animar un poco la imagen
			if((*(automaton2d->graph[index].centerCell)).derecho == true)
				(*(automaton2d->graph[index].centerCell)).derecho = false;
			else
				(*(automaton2d->graph[index].centerCell)).derecho = true;
			copiaCasilla(1);
			limpiaCasilla();
			goto finCasillasVacias;
		}//fin if ve si la casilla de enfrente esta vacia 
		// ve si la casilla de enfrente derecha esta vacia
		else if((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).type == 0){
			printf("la casilla de frenteDerecha esta vacia \n");
			//compia todos los valores de esta casilla a la casilla vacia
			// este if else es solamente para que al moverte se vea mejor el cambio de direccion
			if((*(automaton2d->graph[index].centerCell)).direccion == 1){
				(*(automaton2d->graph[index].centerCell)).direccion = 8;
			}
			else
				(*(automaton2d->graph[index].centerCell)).direccion = (*(automaton2d->graph[index].centerCell)).direccion - 1;
			// este if else es para animar un poco la imagen
			if((*(automaton2d->graph[index].centerCell)).derecho == true)
				(*(automaton2d->graph[index].centerCell)).derecho = false;
			else
				(*(automaton2d->graph[index].centerCell)).derecho = true;
			copiaCasilla(8);
			limpiaCasilla();
			goto finCasillasVacias;
		}//fin else if ve si la casilla de enfrente derecha esta vacia
		// ve si la casilla de enfrente izquierda esta vacia
		else if((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).type == 0){
			printf("la casilla de frenteIzquierda esta vacia \n");
			//compia todos los valores de esta casilla a la casilla vacia
			// este if else es solamente para que al moverte se vea mejor el cambio de direccion
			if((*(automaton2d->graph[index].centerCell)).direccion == 8){
				(*(automaton2d->graph[index].centerCell)).direccion = 1;
			}
			else
				(*(automaton2d->graph[index].centerCell)).direccion = (*(automaton2d->graph[index].centerCell)).direccion + 1;
			// este if else es para animar un poco la imagen
			if((*(automaton2d->graph[index].centerCell)).derecho == true)
				(*(automaton2d->graph[index].centerCell)).derecho = false;
			else
				(*(automaton2d->graph[index].centerCell)).derecho = true;
			copiaCasilla(2);
			limpiaCasilla();
			goto finCasillasVacias;
		}//fin if else ve si la casilla de enfrente izquierda esta vacia
		finCasillasVacias:
			;
	}// fin camina
	/*en este metodo se buscan lagartijas dentro de las casillas visibles*/
	bool buscaComida(){
		//checa casilla por casilla en busca de lagartijas
		if((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).type == 1)
			return true;		
		else if((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).type == 1)
			return true;
		else if((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).type == 1)
			return true;
		else if((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).type == 2)
			return true;
		else if((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).type == 2)
			return true;
		else if((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).type == 2)
			return true;
		// no huvi lagartijas
		else 
			return false;
	}//fin buscaComida()
	/*En este metodo se determina cual de los bichos se comera, entre la/s lagartija/s que
	se encontraron en las casillas visibles, ademas se deve de tomar en cuenta el fondo
	y resolverlo todo de manera probavilistica (aca deve de ir la seleccion natural)*/
	void come(){
		//checamos casilla por casilla si se tiene comida
		
		//primero checa la casilla de enfrente
		if(((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).type == 1)||((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).type == 2)){
			printf("comida en la casilla de enfrente e intentare comer\n");
			//por ahora solo comeremos al que este pronto se tendra que hacer lo de seleccion
			//este if else es para determinar que estas comiendo (para poner la imagen) 
			if((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frente + automaton2d->graph[index].beginNeighbor])).type == 1)
				(*(automaton2d->graph[index].centerCell)).lagartijaVerde = false;
			else
				(*(automaton2d->graph[index].centerCell)).lagartijaVerde = true;
			//pasate a la casilla donde esta la lagartija
			// este if else es para animar un poco la imagen
			if((*(automaton2d->graph[index].centerCell)).derecho == true)
				(*(automaton2d->graph[index].centerCell)).derecho = false;
			else
				(*(automaton2d->graph[index].centerCell)).derecho = true;
			copiaCasilla(1);
			//por ultimo limpia la casilla que avandonas
			limpiaCasilla();
			goto finCome;
		}//fin if checa la casilla de enfrente
		// checa la casilla frente derecha
		else if(((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).type == 1)||((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).type == 2)){
			printf("comida en la casilla de enfrenteDerecha e intentare comer\n");
			//por ahora solo comeremos al que este pronto se tendra que hacer lo de seleccion
			//este if else es para determinar que estas comiendo (para poner la imagen) 
			if((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteDerecha + automaton2d->graph[index].beginNeighbor])).type == 1)
				(*(automaton2d->graph[index].centerCell)).lagartijaVerde = false;
			else
				(*(automaton2d->graph[index].centerCell)).lagartijaVerde = true;

			//pasate a la casilla donde esta la lagartija
			// este if else es para animar un poco la imagen
			if((*(automaton2d->graph[index].centerCell)).derecho == true)
				(*(automaton2d->graph[index].centerCell)).derecho = false;
			else
				(*(automaton2d->graph[index].centerCell)).derecho = true;
			copiaCasilla(8);
			//por ultimo limpia la casilla que avandonas
			limpiaCasilla();
			goto finCome;
		}//fin else if checa la casilla frente derecha
		//checa casilla frente izquierda
		else if(((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).type == 1)||((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).type == 2)){
			printf("comida en la casilla de enfrenteIzquierda e intentare comer\n");
			//por ahora solo comeremos al que este pronto se tendra que hacer lo de seleccion
			//este if else es para determinar que estas comiendo (para poner la imagen) 
			if((*(automaton2d->neighbors[(*(automaton2d->graph[index].centerCell)).frenteIzquierda + automaton2d->graph[index].beginNeighbor])).type == 1)
				(*(automaton2d->graph[index].centerCell)).lagartijaVerde = false;
			else
				(*(automaton2d->graph[index].centerCell)).lagartijaVerde = true;

			//pasate a la casilla donde esta la lagartija
			// este if else es para animar un poco la imagen
			if((*(automaton2d->graph[index].centerCell)).derecho == true)
				(*(automaton2d->graph[index].centerCell)).derecho = false;
			else
				(*(automaton2d->graph[index].centerCell)).derecho = true;
			copiaCasilla(2);
			//por ultimo limpia la casilla que avandonas
			limpiaCasilla();
			goto finCome;
		}//fin else if checa casilla frente izquierda
		finCome:
			;
	}//fin come
	virtual DWORD Run( LPVOID arg ){
		
		while(!salir)
        {
			// seed random number generator en cada iteracion del modelo
			srand(unsigned int(time(&timer))); 
		
			while(!corre&&!salir)
				Sleep(100);			
			
			//*****************************************RULE************************************************************
			//*****************************************RULE************************************************************
			//*****************************************RULE************************************************************
			//*****************************************RULE************************************************************

			//*******************los valorese que representan los tipos**********
			//		type = 0; casilla vacia
			//		type = 1; casilla con lagartija cafe
			//		type = 2; casilla con lagartija verde
			//		type = 3; casilla con gato
			//*****************************************
			
			//**********************las casillas vecinas*********************************
			//
			//					 frenteIzquierda  frente  frenteDerecha    
			//								    \    |   /
			//				           izquierda -centro- derecha
			//								    /    |	 \
			//				      atrasIzquierda   atras  atrasDerecha
			//
			//    (esta es la estructura general la cual gira rigidamente segun la 
			//                              direccion que se use)
			//***************************************************************************

			//*************************las direcciones***********************************
			//
			//								 4  3  2
			//								  \ | /
			//								 5 - - 1
			//								  / | \
			//								 6	7  8
			//
			//***************************************************************************

			int i = 0;
			// checa todas las casillas
			for(int j = 0; j<automaton2d->graph.size(); ++j){
				index = randomList();
				/*este if es para no repetir la funcion de siguiente estado sobre algu bicho
				ya que al moverse a otra casilla puede al cambiar de sitio ser llamado otra vez*/
				if((*(automaton2d->graph[index].centerCell)).actuaste == false){
					// primero checa si la casilla esta con algun tipo de lagartija
					if((*(automaton2d->graph[index].centerCell)).type == 1 || (*(automaton2d->graph[index].centerCell)).type == 2){
						printf("--------casilla con lagartija----------\n");
						
						//como como sea haras algo con este bicho
						(*(automaton2d->graph[index].centerCell)).actuaste = true;

						//checa si el bicho esta en estado juvenil
						if((*(automaton2d->graph[index].centerCell)).juvenil){
							printf("soy juvenil\n");
							// si el bicho deve de pasar tiempo desarollandose
							if((*(automaton2d->graph[index].centerCell)).banderaJuvenil <= 3){
								printf("todavia estoy chico edad = %d\n",(*(automaton2d->graph[index].centerCell)).banderaJuvenil);
								// dale un poco mas de tiempo solo marcandolo en su contador
								(*(automaton2d->graph[index].centerCell)).banderaJuvenil += 1;
							}
							// si el bicho ya esta lo suficientemente desarrollado para ser adulto 
							else{
								//quitale lo juvenil
								(*(automaton2d->graph[index].centerCell)).juvenil = false;
								(*(automaton2d->graph[index].centerCell)).banderaJuvenil = 0;
								//como el bicho ya es de un tipo 
								//solo escoje su pie al frente 
								randomNumber = rand() % 2;
								if(randomNumber == 0)
									(*(automaton2d->graph[index].centerCell)).derecho = true;
								else 
									(*(automaton2d->graph[index].centerCell)).derecho = false;
								//y una direccion
								randomNumber = (rand() % 8)+1;
								(*(automaton2d->graph[index].centerCell)).direccion = randomNumber;
							}//fin else ya es adulto
						}//if juvenil
						else{// si no eres juvenil
							printf("-no eres juvenil-\n");
							//checa si el bicho se esta apareando
							if( (*(automaton2d->graph[index].centerCell)).apareandose == true ){
								printf("bicho apareandose\n");
								// si no lleva el tiempo suficiente apareandose
								if((*(automaton2d->graph[index].centerCell)).banderaApareandose <= 1)
									(*(automaton2d->graph[index].centerCell)).banderaApareandose += 1;
								// si ya termino de aparearse
								else{
									(*(automaton2d->graph[index].centerCell)).apareandose = false;
									(*(automaton2d->graph[index].centerCell)).banderaApareandose = 0;
									// esto se hace para animar la imagen
									if((*(automaton2d->graph[index].centerCell)).derecho == false)
										(*(automaton2d->graph[index].centerCell)).derecho = true;
									else 
										(*(automaton2d->graph[index].centerCell)).derecho = false;
									//y escoge una nueva direccion
									randomNumber = (rand() % 8)+1;
									(*(automaton2d->graph[index].centerCell)).direccion = randomNumber;
								}//fin else ya termino de aparearse
							}//fin bicho apareandose 
							// si el bicho no esta apareandose
							else{
								printf("-bicho no apareandose-\n");
								// alista los indices que te indican que casillas se ven
								(*(automaton2d->graph[index].centerCell)).calculaVista();
								// primero checa que no halla un gato a la vista
								if(checaGato()){
									// como se tuvo un gato a la vista muevete lejos de alli
									printf("se encontro un gato devo de huir\n");
									huye();
								}//fin if checa gato
								// si no huvo un gato 
								else{
									printf("--no veo gato--\n");
									// checa si se tiene alguien con el cual aparearte
									if(checaPareja()){
										printf("-vi una lagartija amiga no juvenil y no apareandose-\n");
										apareate();
										printf("-fin vi una lagartija amiga no juvenil y no apareandose-\n");
									}// if checando si se tienen lagartijas con la cual aparearte
									//si no se tuvo a nadie muevete
									else{
										printf("no veo a nadie amigo\n");
										// primero checa que se tenga un espacio vacio si no no puedes moverte
										if(checaEspacioVacio()){
											printf("encontre una casilla vacia asi que caminare\n");
											camina();
										}// if casillas vacias
										// si no tienes casillas vacias cambia de direccion
										else{
											printf("no veo casillas vacias\n");
											//cambia de direccion
											randomNumber = (rand() % 8) + 1;
											(*(automaton2d->graph[index].centerCell)).direccion = randomNumber;
											// este if else es para animar un poco la imagen
											if((*(automaton2d->graph[index].centerCell)).derecho == true)
												(*(automaton2d->graph[index].centerCell)).derecho = false;
											else
												(*(automaton2d->graph[index].centerCell)).derecho = true;
										}// else no vi casillas vacias
										
									}// fin else no se tuvo a nadie
									printf("--fin no veo gato--\n");
								}//else no huvo gato
								printf("-fin bicho no apareandose-\n");
							}// bicho no apareandose
							printf("-fin no eres juvenil-\n");
						}//else no eres juvenil
						printf("--------fin casilla con lagartija----------\n");
					}//if
					// checa si la casilla tiene gato
					else if((*(automaton2d->graph[index].centerCell)).type == 3){
						printf("--------casilla con gato----------\n");
						// como sea vas a hacer algo asi que
						(*(automaton2d->graph[index].centerCell)).actuaste = true;
						if((*(automaton2d->graph[index].centerCell)).comiendo){
							printf("-gato comiendo-\n");
							if((*(automaton2d->graph[index].centerCell)).banderaComiendo < 2)
								(*(automaton2d->graph[index].centerCell)).banderaComiendo +=1;
							else{
								(*(automaton2d->graph[index].centerCell)).comiendo = false;
								(*(automaton2d->graph[index].centerCell)).banderaComiendo = 0;
								//como el bicho ya comio
								//solo escoje su pie al frente 
								randomNumber = rand() % 2;
								if(randomNumber == 0)
									(*(automaton2d->graph[index].centerCell)).derecho = true;
								else 
									(*(automaton2d->graph[index].centerCell)).derecho = false;
								//y una direccion
								randomNumber = (rand() % 8)+1;
								(*(automaton2d->graph[index].centerCell)).direccion = randomNumber;
							}//fin else gato ya termino de comer
						}// fin if gato comiendo
						// si el gato no esta comiendo
						else{
							printf("-gato sin comer-\n");
							// alista los indices que te indican que casillas se ven
							(*(automaton2d->graph[index].centerCell)).calculaVista();
							//primero checa si tienes alguna lagartija a la vista
							if(buscaComida()){
								printf("veo lagartija y tengo hambre\n");
								// es necesaro desglosar las casillas que tienen lagartijas
								//*********************************************************
								// y escojer entre las lagartijas encontradas con un valor 
								// probabilistico cotejando con el fondo LA SELECCION NATURAL
								//*********************************************************
								come();
							}//if
							// si no hay comida muevete
							else{
								// se deve de escojer entre las casillas vacias
								printf("-no vi lagartija-\n");
								// primero checa que se tenga un espacio vacio si no no puedes moverte
								if(checaEspacioVacio()){
									printf("encontre una casilla vacia asi que caminare\n");
										camina();
								}// if casillas vacias
								// si no tienes casillas vacias cambia de direccion
								else{
									printf("no veo casillas vacias\n");
									//cambia de direccion
									randomNumber = (rand() % 8) + 1;(*(automaton2d->graph[index].centerCell)).direccion = randomNumber;
									// este if else es para animar un poco la imagen
									if((*(automaton2d->graph[index].centerCell)).derecho == true)
										(*(automaton2d->graph[index].centerCell)).derecho = false;
									else
										(*(automaton2d->graph[index].centerCell)).derecho = true;
								}// else no vi casillas vacias
								printf("-no vi lagartija-\n");
							}//fin else no hay comida
							printf("-gato sin comer-\n");
						}//else gato no comiendo
						printf("--------fin casilla con gato----------\n");
					}//else if
				}// este if es por si no avias actuado
			}//for j
			// ya que le diste una ves la buelta ponlos listos para actuar
			for(int j = 0; j<automaton2d->graph.size(); ++j){
				(*(automaton2d->graph[j].centerCell)).actuaste = false;
			}
			
			
			//************************************END***RULE***************************************************************
			//************************************END***RULE***************************************************************
			//************************************END***RULE***************************************************************
			//************************************END***RULE***************************************************************

			// Create object for Single Lock
			printf("model ----------------------------- a cambiar imagenes \n");
			CSingleLock lock(&g_m);

			lock.Lock();
			view->doUpdates();
			Sleep(1500);
			lock.Unlock();	
			
		}
		
		return 0;
	}
};

#endif //Model_H