// To do
// - Fix WaitForSingleObject so that it the Coin thread terminates and signals properly.
// - Put in ASSERTs to check return values
// - Use SbThreads instead for something more robust.

#include "osinterface.h"
#include <cstdlib>
#include <ctime>
#include <winbase.h>
#include <winuser.h>
#include <process.h>
#include <crtdbg.h>
//#include "mex.h"

WNDPROC SoOsInterface::oldEventHandler = NULL;
HANDLE SoOsInterface::mainThreadHandle = NULL;

   
void myFunc(void* classPtr, SoSensor *)
{
    SoOsInterface* i = (SoOsInterface*) classPtr;
	printf("******************* IDLE*****************\n");
    i->isIdle = true; // A variable you add to SoOsInterface
}
SoOsInterface::SoOsInterface()
{
        soRunning = false;
        mainThreadHandle = NULL;
}


SoOsInterface::~SoOsInterface()
{
}

int SoOsInterface::start()
{
        // Start a single thread to handle all 3D graphics
        if (mainThreadHandle == NULL)
        {
                unsigned threadID;
				/**************************************************************
				* The _beginthread function creates a thread that begins 
				* execution of a routine at start_address. The routine 
				* at start_address must use the __cdecl calling convention
				* and should have no return value. When the thread returns 
				* from that routine, it is terminated automatically. 
				****************************************************************/
                mainThreadHandle = (HANDLE) _beginthreadex(NULL, 0, &mainThread, this, 0, &threadID);
				/********************************
				* la referencia a la funcion &mainthread es el argumento pasado al nuevo thread
				* ----------------------------------------------------------
				* this    ========= 
				* Pointer to a SECURITY_ATTRIBUTES structure that determines whether
				* the returned handle can be inherited by child processes. If NULL, the 
				* handle cannot be inherited.
				*--------------------------------------------------------------
				* 0 ============
				* Initial state of a new thread (0 for running or CREATE_SUSPENDED for 
				* suspended); use ResumeThread to execute the thread.
				*-------------------------------------------------------------------
				* &threadID ========
				* Points to a 32-bit variable that receives the thread identifier. Might
				* be NULL, in which case it is not used.
				*/
				
				if (mainThreadHandle == NULL)
                        return 1;
        }

        // Wait for the thread to start up (possibly) and the 3D graphics scene to be created
		// deja de esperar cuando se monto todo, es decir soRunning es true !devo de usarlo!
        while (!soRunning)
                Sleep(100);
        // Inform it updates are ready
        sendUserMessage(2);

        return 0;
}


unsigned _stdcall mainThread(void* classPtr)
{

		// creo que esto biene al pasar this cuando creas el thread
        SoOsInterface* i = (SoOsInterface*) classPtr;
		i->SoMain();
		///cuando se termine la funcion somain terminas
		///el thread explisitamente
        _endthreadex(0);
        return 0;
}

DWORD SoOsInterface::SoMain()
{
        mainWindow = SoWin::init("trunkVrml", "trunkClass");
        if (mainWindow == NULL)
                return 1;

        //------------------- Install my own WM_CLOSE handler-------------------------------------

        HWND tmp = SoWin::getTopLevelWidget();	
		
		/****************************************************************************
		* The GetWindowLong function retrieves information about the specified window.
		* SoWin::getTopLevelWidget()  == Handle to the window and, indirectly, the class 
		* to which the window belongs. 
        * GWL_WNDPROC  === 
		* en este caso Retrieves the address of the window procedure, or a handle 
		* representing the address of the window procedure. You must use the CallWindowProc 
		* function to call the window procedure.
		*
		*este valor se usa para llamar al event handler windowsero dentro del nuevo
		*******************************************************************************/
		oldEventHandler = (WNDPROC) GetWindowLong(SoWin::getTopLevelWidget(), GWL_WNDPROC);
		
		/***************************************************************************
		* The SetWindowLong function changes an attribute of the specified window. The 
		* function also sets the 32-bit (long) value at the specified offset into the 
		* extra window memory.
		* SoWin::getTopLevelWidget() =====
		* Handle to the window and, indirectly, the class to which the window belongs
		* GWL_WNDPROC ==
		* Sets a new address for the window procedure
		* eventHandler == 
		* Specifies the replacement value.
		* con esto ya creaste el nuevo event handler y se maneja dentro de la funcion
		* eventHandler
		*/
		SetWindowLong(SoWin::getTopLevelWidget(), GWL_WNDPROC, (long) eventHandler);
		//-------------------fin -- Install my own WM_CLOSE handler------------------------------

        viewer = new SoWinExaminerViewer(mainWindow);
        
		SoIdleSensor* idle = new SoIdleSensor(myFunc, this);
		idle->schedule();

        soRunning = true;
        SoWin::mainLoop();
		soRunning = false;

        delete viewer;

        mainThreadHandle = NULL;

        // Unregister classes SoWin forgets to clean up.
        // ---------------------------------------------
        // SoWinP::OnQuit never gets called, so the main window class never gets unregistered.
        //   Can't call OnQuit (SoWinP is private).  So unregister it manually.
        // The "ThumbWheel Widget" should be cleaned up in the SoWinThumbWheel destructor (see SoWinThumbWheel.cpp).
        //   But an if statement (if (SoWinThumbWheel::wheelWidgetCounter == 0)) prevents this from happening.
        // The "Component Widget"'s unregisterclass call is #ifdefed out in the SoWinComponentP destructor (see SoWinComponent.cpp).
        // The "Manager Widget", "GL Widget", and "sowin_glwidget_temp" get cleaned up in the SoWinGLWidget destructor (see SoWinGlWidget.cpp)
        char* classes[3] = { "trunkClass", "ThumbWheel Widget", "Component Widget" };
        for (int ii = 0; ii < 3; ii++)
                if (UnregisterClass(LPCWSTR(classes[ii]), NULL) == 0)
                        return -1;

        return NULL;
}


// A custom message handler
LRESULT CALLBACK SoOsInterface::eventHandler(HWND window, UINT message, WPARAM wparam, LPARAM lparam)
{
        // If we send ourselves the close message, then actually close the window.
        // If a user clicks close, ignore it.
        SoOsInterface* i = (SoOsInterface*) wparam;
        switch (message)
        {
        case WM_CLOSE :
                // The window is already hidden; refuse the request to terminate.
                // Do that when the dll is freed.
            SoWin::exitMainLoop();    
			return 0;
//                return CallWindowProc(oldEventHandler, window, message, wparam, lparam);

        // Process a DLL close message
        case WM_USER :
                return CallWindowProc(oldEventHandler, window, WM_CLOSE, wparam, lparam);

        // Process updates sent from the other thread
        case WM_USER + 1:
                i->doUpdates();
                return 0;

        case WM_USER + 2:
                i->viewer->setSceneGraph(i->createRoot());
                i->viewer->show();
                SoWin::show(i->mainWindow);
                return 0;

        case WM_USER + 3:
                SoWin::hide(i->mainWindow);
                i->freeRoot();
                return 0;
        
        // Process all other Windows messages
        default :
                return CallWindowProc(oldEventHandler, window, message, wparam, lparam);
        }
}


// Exit the graphics thread when the DLL is unloaded.
BOOL WINAPI DllMain (HANDLE hModule,
                     DWORD fdwreason, LPVOID lpReserved )
{
    switch (fdwreason)
        {
                case DLL_PROCESS_ATTACH:
                        // The DLL is being mapped into process's address space
                        //  Do any required initialization on a per application basis, return FALSE if failed
                break;

                case DLL_THREAD_ATTACH:
                        // A thread is created. Do any required initialization on a per thread basis
                break;

                case DLL_THREAD_DETACH:
                        // Thread exits with cleanup
                break;

                case DLL_PROCESS_DETACH:
                        // The DLL was unmapped from process's address space. Do necessary cleanup.
                        // Close the graphics window, which terminates the graphics thread
                        PostMessage(SoWin::getTopLevelWidget(), WM_USER, 0, 0);
                        // Wait for the thread to finish. DllMain holds a lock that prevents
                        // this thread from fully shutting down, so wait a little.
                        // If the thread was already terminated, this completes immediately.
                        if (WaitForSingleObject(SoOsInterface::mainThreadHandle, 500) != WAIT_OBJECT_0)
                                // If not, rip it out.
                                TerminateThread(SoOsInterface::mainThreadHandle, 0);
                        // Give up the handle to the thread
                        CloseHandle(SoOsInterface::mainThreadHandle);
                break;
    }
    return TRUE;
}


void SoOsInterface::term()
{
        // Wait for the scene to close down
        sendUserMessage(3);
}