#include <Inventor/Win/SoWin.h>
#include <Inventor/Win/viewers/SoWinExaminerViewer.h>
#include <windows.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/sensors/SoTimerSensor.h>
#include <Inventor/SoOffscreenRenderer.h>
#include <Inventor/sensors/SoIdleSensor.h>

class SoOsInterface
{
protected:
        bool soRunning;

//        SoNode *snapShotNode;//snapShot
//        SoOffscreenRenderer *myRenderer;

        virtual SoSeparator* createRoot() = 0;
        virtual void freeRoot() = 0;
		
		//este es literal
        HWND mainWindow;
		//y este es un clasico literal tambien
        SoWinExaminerViewer* viewer;
		// este se usa para tener accseso al handler windowsero ya que usas uno nuevo
        static WNDPROC oldEventHandler;
		
		//este es el metodo que llamas cuando creas el thread en start()
		// aca simplemente llamas a soMain y cuando se acava el loop de so win 
		//terminas explisitamente el thread
        friend unsigned _stdcall mainThread(void* classPtr);
		// este es el metodo que usas para sustituir el handler windowsero
        static LRESULT CALLBACK eventHandler(HWND window, UINT message, WPARAM wparam, LPARAM lparam);
		
		//en este metodo haces todo lo clasico SoWin como creal la bentana, pero ademas
		//cambias del handler windosero al tullo y cunado termina el llop main de sowin
		//terminas el registro de la ventana principal de manera manual
        DWORD SoMain();

        // Post a user message to the Open Inventor window
        BOOL postUserMessage(int msg)
        {
                return PostMessage(SoWin::getTopLevelWidget(), WM_USER + msg, (WPARAM) this, 0);
        }

        // Send a message to the Open Inventor window, waiting until it is processed
        LRESULT sendUserMessage(int msg)
        {
			/***********************************************************************
			* The SendMessage function sends the specified message to a window or windows. 
			* It calls the window procedure for the specified window and does not return 
			* until the window procedure has processed the message. 
			*/
                return SendMessage(SoWin::getTopLevelWidget(), WM_USER + msg, (WPARAM) this, 0);
			/**********************************
			-------------------------------------------------------------------------
			*   SoWin::getTopLevelWidget() ======
			* Handle to the window whose window procedure will receive the message. 
			* If this parameter is HWND_BROADCAST, the message is sent to all top-level 
			* windows in the system, including disabled or invisible unowned windows, 
			* overlapped windows, and pop-up windows; but the message is not sent to 
			* child windows.
			-----------------------------------------------------------------------
			*  WM_USER + msg     =====
			* Specifies the message to be sent.
			*-----------------------------------------------------------------------
			* (WPARAM) this ============
			* Specifies additional message-specific information.
			* -----------------------------------------------------------------------
			* 0 =========
			* Specifies additional message-specific information.
			*
			*********************************************************************************/

        }


public:

		// este guey es el nuevo thread creado (donde va todo el viaje sowin)
        static HANDLE mainThreadHandle;
		
		//te dice si se anda rendereando
		bool isIdle;

        virtual void doUpdates() = 0;
public:
        SoOsInterface();
        ~SoOsInterface();
		/*en este metodo se crea el thread y se espera a que todo este listo y se havisa cuando
		lo esta mandando un mensaje de valor 2, el thread llama a  la funcion mainthread*/
        virtual int start();
        virtual void term();
        bool isRunning() { return soRunning; };

        // Notify the Open Inventor thread that updates are ready
        BOOL postUpdates()    { return postUserMessage(1); };
        LRESULT sendUpdates() { return sendUserMessage(1); };
};