#ifndef valores_H
#define valores_H
#include <ctime>
#include <iostream>
#include <cstdlib> 

#include "Bicho.h"

using namespace std;

// numeo de estados y tamao de la gradilla
const int states = 7;
const  int xmax = 25, ymax = 25;

Bicho statesMatrix[xmax][ymax];
Bicho statesMatrixnt1[xmax][ymax];
const int dimencions2D = 2;
int dimSizes2D[dimencions2D] = {xmax, ymax};

// valores para determinar cual de los dos tipos
// es dominante y cual resesivo
int dominante = 2;
int resesivo  = 1;
/*y este es para ver contra cual actua la seleccion
Por ahora si es cero no se favorese a nadie, si es 1 es contra lagartija
cafe y si es 2 contra lagartija verde*/
int seleccionContra = 0;

//variables para sincronizar vista y modelo
bool corre = false; 
bool stop = true;
bool clean = false;
bool set = false;
bool salir = false;

//valores que conforman el rgb del cuadrado de fondo
float rojo = .99;
float verde = .99;
float azul = .99;  

// valores para determinar cuanto se tiene de cada tipo
int lagartijaCafe = 0;
int lagartijaVerde = 0;
int aleloDominante = 0;
int aleloRecesivo = 0;
int iteracion = 0;

void init(){
	printf("dominantes = %d, resesivos = %d\n", dominante, resesivo);
	//aca se guarda el valor generado al azar cuando es necesario
	int randomNumber = 0;
	
	time_t timer;
	srand(unsigned int(time(&timer))); // seed random number generator by i
	for(int i = 0; i<xmax;++i){
		for(int j = 0; j<ymax;++j){
			// escoje entre casilla vacia, homosigo dominante, hom resesivo, heterosigo y gato
			randomNumber = rand()%100;
			//printf("random = %d\n", randomNumber);
			//crea una casilla vacia
			if(randomNumber <45){
				statesMatrix[i][j].type = 0;
				//printf("vacio\n");
			}
			//crea los homosigos dominantes
			else if((45 <= randomNumber)&&(randomNumber < 60)){
				statesMatrix[i][j].type = dominante;
				statesMatrix[i][j].alelo1 = dominante;
				statesMatrix[i][j].alelo2 = dominante;
				//printf("especie = %d\n",dominante);
				//printf("alelo1 = %d\n", statesMatrix[i][j].alelo1);
				//printf("alelo2 = %d\n", statesMatrix[i][j].alelo2);
			}
			//crea los homosigos resesivos
			else if((60 <= randomNumber)&&(randomNumber < 75)){
				statesMatrix[i][j].type = resesivo;
				statesMatrix[i][j].alelo1 = resesivo;
				statesMatrix[i][j].alelo2 = resesivo;
				//printf("especie = %d\n",resesivo);
				//printf("alelo1 = %d\n", statesMatrix[i][j].alelo1);
				//printf("alelo2 = %d\n", statesMatrix[i][j].alelo2);
			}
			//crea los heterosigos
			else if((75 <= randomNumber)&&(randomNumber < 90)){
				statesMatrix[i][j].type  = dominante;
				statesMatrix[i][j].alelo1 = resesivo;
				statesMatrix[i][j].alelo2 = dominante;
				//printf("especie = %d\n",dominante);
				//printf("alelo1 = %d\n", statesMatrix[i][j].alelo1);
				//printf("alelo2 = %d\n", statesMatrix[i][j].alelo2);
			}
			//crea gato
			else{
				statesMatrix[i][j].type = 3;
				//printf("especie = 3\n");
			}
			statesMatrix[i][j].direccion = (rand() % 8) + 1;
			statesMatrix[i][j].juvenil = false;
			statesMatrix[i][j].banderaJuvenil = 0;
			statesMatrix[i][j].apareandose = false;
			statesMatrix[i][j].banderaJuvenil = 0;
			statesMatrix[i][j].comiendo = false;
			statesMatrix[i][j].banderaComiendo = 0;
			statesMatrix[i][j].lagartijaVerde = false;
			statesMatrix[i][j].actuaste = false;
			randomNumber = rand()%2;
			if(randomNumber == 0)
				statesMatrix[i][j].derecho = true;
			else
				statesMatrix[i][j].derecho = false;
		}//for j
	}// for i	
}
void limpiaTodo(){
	for(int i = 0; i<xmax;++i)
		for(int j = 0; j<ymax;++j){
			statesMatrix[i][j].type = 0;
			statesMatrix[i][j].juvenil = false;
			statesMatrix[i][j].banderaJuvenil = 0;
			statesMatrix[i][j].apareandose = false;
			statesMatrix[i][j].banderaJuvenil = 0;
			statesMatrix[i][j].derecho = true;
			statesMatrix[i][j].direccion = 1;
			statesMatrix[i][j].comiendo = false;
			statesMatrix[i][j].banderaComiendo = 0;
			statesMatrix[i][j].alelo1 = 0;
			statesMatrix[i][j].alelo2 = 0;
			statesMatrix[i][j].actuaste = false;
		}
}

// este metodo cuenta cuantos bichos se tienen de cada tipo
void calculaCantidades(){
	
	lagartijaCafe = 0;
	lagartijaVerde = 0;
	aleloDominante = 0;
	aleloRecesivo = 0;
	for(int i =0; i< xmax;++i)
		for(int j = 0; j < ymax; ++j){
			if(statesMatrix[i][j].type == 1){
				lagartijaCafe += 1;
				if(statesMatrix[i][j].alelo1 == dominante)
					aleloDominante += 1;
				else
					aleloRecesivo += 1;
				if(statesMatrix[i][j].alelo2 == dominante)
					aleloDominante += 1;
				else
					aleloRecesivo += 1;
			}
			else if(statesMatrix[i][j].type == 2){
				lagartijaVerde += 1;
				if(statesMatrix[i][j].alelo1 == dominante)
					aleloDominante += 1;
				else
					aleloRecesivo += 1;
				if(statesMatrix[i][j].alelo2 == dominante)
					aleloDominante += 1;
				else
					aleloRecesivo += 1;
			}
		}
	printf("Lcafe = %d, Lverde = %d\n",lagartijaCafe, lagartijaVerde);
	printf("aleloDominante = %d, aleloRecesivo = %d\n",aleloDominante, aleloRecesivo);
	
}
#endif