#ifndef View_H
#define View_H

#include <windows.h>
#include <winbase.h>
#include <string.h>
#include "Thread.h"
#include "celula.h"
#include "valores.h"
//*********************************TODO EL VIAJE DE COIN3D Y SOWIN **********
#include <Inventor/Win/SoWin.h>


#include <Inventor/Win/viewers/SoWinExaminerViewer.h>
#include <Inventor/nodes/SoSelection.h>
#include <Inventor/actions/SoBoxHighlightRenderAction.h>
#include <Inventor/SoPath.h>

#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoGroup.h>

#include <Inventor/nodes/SoCoordinate3.h>
#include <Inventor/nodes/SoTranslation.h>

#include <Inventor/nodes/SoFaceSet.h>

#include <Inventor/nodes/SoTexture2.h>
#include <Inventor/nodes/SoBaseColor.h>

#include <Inventor/sensors/SoIdleSensor.h>


#include <Inventor/nodes/SoLineSet.h>
//*************************************************************************
// *************************************************************************

#define PLAY        101             // first check box 
#define STOP        102             // second check box 
#define LIMPIA      103             // second check box 
#define LLENA       104             // second check box 

#define VERDE        111
#define CAFE         105            
#define BLANCO       106
#define GENDOMINANTE 107
#define LCAFE        108
#define LVERDE       109
#define GATO         110

#define EDT_MESSAGE            2

static int jjj = 1;

// Global data.
static SoSelection * selection;
static SoTexture2 *texturas[53];
static celula *grid[xmax][ymax];
static SoSeparator* root;

HWND botonGenDominante;
HANDLE  genDominante1;
HANDLE  genDominante2;

bool gato = false;
bool lcafe = false;
bool lverde= false;

int banderaSeleccionado;
SoBaseColor * col;
SoBaseColor *coco = new SoBaseColor;
SoSeparator *fondo;
bool isIdle = false;
// este se usa para tener accseso al handler windowsero ya que usas uno nuevo        
static WNDPROC oldEventHandler;

//este es para evitar cambiar la imagen cuando no es necesario
int copiaStatesMatrix[xmax][ymax];

//\\\\\\\\\\\\ veriables para la series de tiempo \\\\\\\\\\\\\\\\\\\\\\\
//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//que tan larga son las series
const int NUMPOINTS = 200;

//puntos de referencia "eje X y Y"
float ejeX[2][3];
float ejeY[2][3];

// puntos de la poblacion de lagartija verde
float serieVerde[NUMPOINTS][3];
SoCoordinate3 * coordsLVerdeA= new SoCoordinate3;		
SoCoordinate3 * coordsLVerdeB = new SoCoordinate3;		
SoSeparator * lineaVerde;

//puntos de la poblacion de lagartija cafe
float serieCafe[NUMPOINTS][3];
SoCoordinate3 * coordsLCafeA = new SoCoordinate3;		
SoCoordinate3 * coordsLCafeB = new SoCoordinate3;		
SoSeparator * lineaCafe;

//puntos de la poblacion de alelos Dominantes
float serieDominante[NUMPOINTS][3];
SoCoordinate3 * coordsDominanteA = new SoCoordinate3;		
SoCoordinate3 * coordsDominanteB = new SoCoordinate3;		
SoSeparator * lineaDominante;

//puntos de la poblacion de alelos Recesivos
float serieRecesivo[NUMPOINTS][3];
SoCoordinate3 * coordsRecesivoA = new SoCoordinate3;		
SoCoordinate3 * coordsRecesivoB = new SoCoordinate3;		
SoSeparator * lineaRecesivo;

// este valor es necesario para actualizar las series (alternar la socoordinate3)
bool banderita = true;
float diferencia = float(ymax)/5;
float numero = float(-ymax - diferencia);
//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\


void myFunc(void* classPtr, SoSensor *)
{
    printf("******************* IDLE*****************\n");
    isIdle = true; // A variable you add to SoOsInterface
}
// Callback function triggered for selection / deselection.
static void made_selection(void * userdata, SoPath * path)
{	
	path->truncate(path->getLength()-1);
	celula *cel = (celula*)path->getTail();
	int flag =0;
	if(lcafe){
		statesMatrix[cel->x][cel->y].type = 1;
		if((rand()%2) == 0){
			statesMatrix[cel->x][cel->y].derecho = true;
			flag = 2;
		}
		else{
			statesMatrix[cel->x][cel->y].derecho = false;
			flag = 10;
		}
		//crea los alelos
		statesMatrix[cel->x][cel->y].alelo1 = 1;
		if(statesMatrix[cel->x][cel->y].type == dominante){
			if((rand()%2) == 0)
				statesMatrix[cel->x][cel->y].alelo2 = 1;		
			else
				statesMatrix[cel->x][cel->y].alelo2 = 2;
		}
		else
			statesMatrix[cel->x][cel->y].alelo2 = 1;			
	}
	else if(lverde){
		statesMatrix[cel->x][cel->y].type = 2;
		if((rand()%2) == 0){
			statesMatrix[cel->x][cel->y].derecho = true;
			flag = 19;
		}
		else{
			statesMatrix[cel->x][cel->y].derecho = false;
			flag = 27;
		}
		//crea los alelos
		statesMatrix[cel->x][cel->y].alelo1 = 2;
		if(statesMatrix[cel->x][cel->y].type == dominante){
			if((rand()%2) == 0)
				statesMatrix[cel->x][cel->y].alelo2 = 1;		
			else
				statesMatrix[cel->x][cel->y].alelo2 = 2;
		}
		else
			statesMatrix[cel->x][cel->y].alelo2 = 2;
	}
	else if(gato){
		statesMatrix[cel->x][cel->y].type = 3;
		if((rand()%2) == 0){
			statesMatrix[cel->x][cel->y].derecho = true;
			flag = 35;
		}
		else{
			statesMatrix[cel->x][cel->y].derecho = false;
			flag = 43;
		}
	}
	else 
		goto end;
	statesMatrix[cel->x][cel->y].direccion = (rand() % 8) + 1;
	statesMatrix[cel->x][cel->y].juvenil = false;
	statesMatrix[cel->x][cel->y].banderaJuvenil = 0;
	statesMatrix[cel->x][cel->y].apareandose = false;
	statesMatrix[cel->x][cel->y].banderaJuvenil = 0;
	statesMatrix[cel->x][cel->y].comiendo = false;
	statesMatrix[cel->x][cel->y].banderaComiendo = 0;
	statesMatrix[cel->x][cel->y].lagartijaVerde = false;
	statesMatrix[cel->x][cel->y].actuaste = false;
	
	switch(statesMatrix[cel->x][cel->y].direccion) {
		case 1 : 
			if(copiaStatesMatrix[cel->x][cel->y] != flag){
				grid[cel->x][cel->y]->replaceChild(grid[cel->x][cel->y]->textura,texturas[flag]);
				grid[cel->x][cel->y]->setTexture(texturas[flag]);
				copiaStatesMatrix[cel->x][cel->y] = flag;
			}
			break;
		case 2 : 
			if(copiaStatesMatrix[cel->x][cel->y] != flag+1){
				grid[cel->x][cel->y]->replaceChild(grid[cel->x][cel->y]->textura,texturas[flag+1]);
				grid[cel->x][cel->y]->setTexture(texturas[flag+1]);
				copiaStatesMatrix[cel->x][cel->y] = flag+1;
			}
			break;
		case 3 : 
			if(copiaStatesMatrix[cel->x][cel->y] != flag+2){
				grid[cel->x][cel->y]->replaceChild(grid[cel->x][cel->y]->textura,texturas[flag+2]);
				grid[cel->x][cel->y]->setTexture(texturas[flag+2]);
				copiaStatesMatrix[cel->x][cel->y] = flag+2;
			}
			break;
		case 4 : 
			if(copiaStatesMatrix[cel->x][cel->y] != flag+3){
				grid[cel->x][cel->y]->replaceChild(grid[cel->x][cel->y]->textura,texturas[flag+3]);
				grid[cel->x][cel->y]->setTexture(texturas[flag+3]);
				copiaStatesMatrix[cel->x][cel->y] = flag+3;
			}
			break;
		case 5 : 
			if(copiaStatesMatrix[cel->x][cel->y] != flag+4){
				grid[cel->x][cel->y]->replaceChild(grid[cel->x][cel->y]->textura,texturas[flag+4]);
				grid[cel->x][cel->y]->setTexture(texturas[flag+4]);
				copiaStatesMatrix[cel->x][cel->y] = flag+4;
			}
			break;
		case 6 : 
			if(copiaStatesMatrix[cel->x][cel->y] != flag+5){
				grid[cel->x][cel->y]->replaceChild(grid[cel->x][cel->y]->textura,texturas[flag+5]);
				grid[cel->x][cel->y]->setTexture(texturas[flag+5]);
				copiaStatesMatrix[cel->x][cel->y] = flag+5;
			}
			break;
		case 7 : 
			if(copiaStatesMatrix[cel->x][cel->y] != flag+6){
				grid[cel->x][cel->y]->replaceChild(grid[cel->x][cel->y]->textura,texturas[flag+6]);
				grid[cel->x][cel->y]->setTexture(texturas[flag+6]);
				copiaStatesMatrix[cel->x][cel->y] = flag+6;
			}
			break;
		default:
			if(copiaStatesMatrix[cel->x][cel->y] != flag+7){ 
				grid[cel->x][cel->y]->replaceChild(grid[cel->x][cel->y]->textura,texturas[flag+7]);									
				grid[cel->x][cel->y]->setTexture(texturas[flag+7]);
				copiaStatesMatrix[cel->x][cel->y] = flag+7;
			}					
	} //end switch
	selection->touch(); // to redraw
	end:
		;
}
static void made_deselection(void * userdata, SoPath * path){
}



class View : public CThread{

		
	void cargaImagenes(){
	
		for(int i = 0; i < 53; ++i){
			texturas[i] = new SoTexture2();
			texturas[i]->ref();
		}
		texturas[0]->filename.setValue("vacio.png");
		texturas[1]->filename.setValue("lch.png");			
		texturas[2]->filename.setValue("lcd1.png");
		texturas[3]->filename.setValue("lcd2.png");
		texturas[4]->filename.setValue("lcd3.png");
		texturas[5]->filename.setValue("lcd4.png");
		texturas[6]->filename.setValue("lcd5.png");
		texturas[7]->filename.setValue("lcd6.png");
		texturas[8]->filename.setValue("lcd7.png");
		texturas[9]->filename.setValue("lcd8.png");
		texturas[10]->filename.setValue("lci1.png");
		texturas[11]->filename.setValue("lci2.png");
		texturas[12]->filename.setValue("lci3.png");
		texturas[13]->filename.setValue("lci4.png");
		texturas[14]->filename.setValue("lci5.png");
		texturas[15]->filename.setValue("lci6.png");
		texturas[16]->filename.setValue("lci7.png");
		texturas[17]->filename.setValue("lci8.png");
		texturas[18]->filename.setValue("lvh.png");			
		texturas[19]->filename.setValue("lvd1.png");
		texturas[20]->filename.setValue("lvd2.png");
		texturas[21]->filename.setValue("lvd3.png");
		texturas[22]->filename.setValue("lvd4.png");
		texturas[23]->filename.setValue("lvd5.png");
		texturas[24]->filename.setValue("lvd6.png");
		texturas[25]->filename.setValue("lvd7.png");
		texturas[26]->filename.setValue("lvd8.png");
		texturas[27]->filename.setValue("lvi1.png");
		texturas[28]->filename.setValue("lvi2.png");
		texturas[29]->filename.setValue("lvi3.png");
		texturas[30]->filename.setValue("lvi4.png");
		texturas[31]->filename.setValue("lvi5.png");
		texturas[32]->filename.setValue("lvi6.png");
		texturas[33]->filename.setValue("lvi7.png");
		texturas[34]->filename.setValue("lvi8.png");			
		texturas[35]->filename.setValue("gd1.png");
		texturas[36]->filename.setValue("gd2.png");
		texturas[37]->filename.setValue("gd3.png");
		texturas[38]->filename.setValue("gd4.png");
		texturas[39]->filename.setValue("gd5.png");
		texturas[40]->filename.setValue("gd6.png");
		texturas[41]->filename.setValue("gd7.png");
		texturas[42]->filename.setValue("gd8.png");
		texturas[43]->filename.setValue("gi1.png");
		texturas[44]->filename.setValue("gi2.png");
		texturas[45]->filename.setValue("gi3.png");
		texturas[46]->filename.setValue("gi4.png");
		texturas[47]->filename.setValue("gi5.png");
		texturas[48]->filename.setValue("gi6.png");
		texturas[49]->filename.setValue("gi7.png");
		texturas[50]->filename.setValue("gi8.png");
		texturas[51]->filename.setValue("gclc.png");
		texturas[52]->filename.setValue("gclv.png");
	}//fin carga imagenes()

	//este es literal
    HWND mainWindow;
	//y este es un clasico literal tambien
    SoWinExaminerViewer* viewer;

    // Post a user message to the Open Inventor window
    BOOL postUserMessage(int msg)
        {
                return PostMessage(SoWin::getTopLevelWidget(), WM_USER + msg, (WPARAM) this, 0);
        }

    // Send a message to the Open Inventor window, waiting until it is processed
    LRESULT sendUserMessage(int msg)
        {
			printf("mandando mensaje valor = %d\n", msg);
			/***********************************************************************
			* The SendMessage function sends the specified message to a window or windows. 
			* It calls the window procedure for the specified window and does not return 
			* until the window procedure has processed the message. 
			*/
			return SendMessage(SoWin::getTopLevelWidget(), WM_USER + msg, (WPARAM) this->getHandle(), 0);
			/**********************************
			-------------------------------------------------------------------------
			*   SoWin::getTopLevelWidget() ======
			* Handle to the window whose window procedure will receive the message. 
			* If this parameter is HWND_BROADCAST, the message is sent to all top-level 
			* windows in the system, including disabled or invisible unowned windows, 
			* overlapped windows, and pop-up windows; but the message is not sent to 
			* child windows.
			-----------------------------------------------------------------------
			*  WM_USER + msg     =====
			* Specifies the message to be sent.
			*-----------------------------------------------------------------------
			* (WPARAM) this ============
			* Specifies additional message-specific information.
			* -----------------------------------------------------------------------
			* 0 =========
			* Specifies additional message-specific information.
			*
			*********************************************************************************/

        }


	void creaboton(LPCSTR nombreImagen, HMENU mensaje){
		// primero carga el bitmap para ponerlo en el boton
		HANDLE  imagens =LoadImage(
		GetModuleHandle(NULL),//HINSTANCE hinst 
		nombreImagen,            //LPCTSTR lpszName
		IMAGE_BITMAP,         //UINT uType
		30,        //int cxDesired
		30,            //int cyDesired  
		LR_LOADFROMFILE);     //UINT fuLoad
			
		//crea el boton
		HWND boton =CreateWindow(
			"button",
			NULL,
			 WS_CHILD|WS_VISIBLE|BS_BITMAP|BS_PUSHBUTTON,
			1,1,
			1,1,
			mainWindow,
			mensaje,	
			0,
			0);
		//coloca al boton la imagen
		SendMessage(boton,(UINT) BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)imagens);
		//pon el boton listo en la pantalla de despliege
		viewer->addAppPushButton(boton);

	}
	void creaBotones(){
		
		creaboton("play.bmp", (HMENU)PLAY);
		creaboton("stop.bmp", (HMENU)STOP);
		/*este boton es para quitar todas las figuras y igualar todos los elementos
		del CA a cero llamando a limpiaTodo en valores.h*/
		creaboton("limpia.bmp", (HMENU)LIMPIA);
		/*este boton es para llenar con figuras y variar los estados de las casillas del
		Ca llamand al metodo init() en valores.h*/
		creaboton("llena.bmp", (HMENU)LLENA);
		/*cambia el tipo de suelo a verde y modifica el valor de seleccion en contra, contra cafes*/
		creaboton("verde.bmp", (HMENU)VERDE);
		/*cambia el tipo de suelo a cafe y modifica el valor de seleccion en contra, contra verdes*/
		creaboton("cafe.bmp", (HMENU)CAFE);
		/*cambia el tipo de suelo a blanco y modifica el valor de seleccion en contra, contra nadie*/
		creaboton("blanco.bmp", (HMENU)BLANCO);
		/// se necestita le handle del boton genDominante asi que ni pex... se hace todo a mano
		/*cambia el valor del gen que representa la tipo dominante*/
		// primero carga el bitmap para ponerlo en el boton
		genDominante1 =LoadImage(GetModuleHandle(NULL),"genDominante1.bmp",IMAGE_BITMAP,30,30,LR_LOADFROMFILE);  
		genDominante2 =LoadImage(GetModuleHandle(NULL),"genDominante2.bmp",IMAGE_BITMAP,30,30,LR_LOADFROMFILE);  
		//crea el boton
		botonGenDominante =CreateWindow("button",NULL,WS_CHILD|WS_VISIBLE|BS_BITMAP|BS_PUSHBUTTON,1,1,1,1,mainWindow,(HMENU)GENDOMINANTE,0,0);
		//coloca al boton la imagen
		if(dominante == 1)		
			SendMessage(botonGenDominante,(UINT) BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)genDominante1);
		else
			SendMessage(botonGenDominante,(UINT) BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)genDominante2);
		//pon el boton listo en la pantalla de despliege
		viewer->addAppPushButton(botonGenDominante);
		/*este boton es para poner la imagen de una lagartija cafe*/
		creaboton("lcafe.bmp", (HMENU)LCAFE);
		/*este boton es para poner la imagen de una lagartija verde*/
		creaboton("lverde.bmp", (HMENU)LVERDE);
		/*este boton es para poner la imagen de un gato*/
		creaboton("gato.bmp", (HMENU)GATO);
	}

	SoSelection* createRoot(){
		root = new SoSeparator;
		root->ref();
		selection = new SoSelection;
		selection->policy = SoSelection::SHIFT;
		selection->ref();
		cargaImagenes();
		celula::initClass();
		int flag = 0;
		for(int i =0; i< xmax;++i)
			for(int j = 0; j < ymax; ++j){
				grid[i][j] = new celula();
				flag =0;
				if(statesMatrix[i][j].type == 0){
					grid[i][j]->setTexture(texturas[0]);
					//iguala la matriz de estados con la guardada
					copiaStatesMatrix[i][j] = 0;
					goto endImagenes;
				}
				else if(statesMatrix[i][j].type == 1)
				{
					if(statesMatrix[i][j].juvenil == true){
						grid[i][j]->setTexture(texturas[1]);
						copiaStatesMatrix[i][j] = 1;
						goto endImagenes;
					}
					else{
						if(statesMatrix[i][j].derecho == true)
							flag = 2;
						else
							flag = 10;
					}//else

				}//else if
				else if(statesMatrix[i][j].type == 2)
				{
					if(statesMatrix[i][j].juvenil == true){
						grid[i][j]->setTexture(texturas[18]);
						copiaStatesMatrix[i][j] = 18;
						goto endImagenes;
					}
					else{
						if(statesMatrix[i][j].derecho == true)
							flag = 19;
						else
							flag = 27;
					}//else
				}//else if
				else if(statesMatrix[i][j].type == 3)
				{
					if(statesMatrix[i][j].comiendo == true){
						if(statesMatrix[i][j].lagartijaVerde == true){
							grid[i][j]->setTexture(texturas[52]);
							copiaStatesMatrix[i][j] = 52;
						}
						else{
							grid[i][j]->setTexture(texturas[51]);
							copiaStatesMatrix[i][j] = 51;
						}
						goto endImagenes;
					}
					else{
						if(statesMatrix[i][j].derecho == true)
							flag = 35;
						else
							flag = 43;

					}//else
				}//else if
				switch(statesMatrix[i][j].direccion) {
					case 1 : 
						grid[i][j]->setTexture(texturas[flag]);
						copiaStatesMatrix[i][j] = flag;
						break;
					case 2 : 
						grid[i][j]->setTexture(texturas[flag+1]);
						copiaStatesMatrix[i][j] = flag+1;
						break;
					case 3 : 
						grid[i][j]->setTexture(texturas[flag+2]);
						copiaStatesMatrix[i][j] = flag+2;							
						break;
					case 4 : 
						grid[i][j]->setTexture(texturas[flag+3]);
						copiaStatesMatrix[i][j] = flag+3;
						break;
					case 5 : 
						grid[i][j]->setTexture(texturas[flag+4]);
						copiaStatesMatrix[i][j] = flag+4;
						break;
					case 6 : 
						grid[i][j]->setTexture(texturas[flag+5]);
						copiaStatesMatrix[i][j] = flag+5;
						break;
					case 7 : 
						grid[i][j]->setTexture(texturas[flag+6]);
						copiaStatesMatrix[i][j] = flag+6;
						break;
					default: 
						grid[i][j]->setTexture(texturas[flag+7]);
						copiaStatesMatrix[i][j] = flag+7;
				} //end switch
				endImagenes:
				;
				grid[i][j]->setCoordinates(i, j);
				grid[i][j]->init();
				grid[i][j]->SetPosition(SbVec3f(float(i), float(-j), .0f));
				
				root->addChild(grid[i][j]);
			}//for j
		selection->addChild(root);
		selection->addSelectionCallback(made_selection, (void *)1L);
		selection->addDeselectionCallback(made_deselection, (void *)0L);


		//***********crea el fondo****************************************
		fondo = new SoSeparator;
		//SoTexture2 * textura;
		
		SoTranslation *trans = new SoTranslation;
		//pones las cordenadas de un cuadrado de lado xmax, ymax
		SoCoordinate3 *coords = new SoCoordinate3;
		coords->point.set1Value(0, SbVec3f(0, -ymax+1, 0));
		coords->point.set1Value(1, SbVec3f(xmax, -ymax+1, 0));
		coords->point.set1Value(2, SbVec3f(xmax, 1, 0));
		coords->point.set1Value(3, SbVec3f(0, 1, 0));
		SoFaceSet *face = new SoFaceSet;
		
		col = new SoBaseColor;
		col->rgb = SbColor(rojo, verde, azul);
		fondo->addChild(col);
		
		//pones la cara, sus cordenadas y la tranlacion
		fondo->addChild(trans);
		fondo->addChild(coords);
		fondo->addChild(face);
		trans->translation = SbVec3f(.0f, .0f, -.1f);
		//y le diece a la car el numero de vertices aue tiene
		face->numVertices.setValue(4);
		selection->addChild(fondo);
		//****************************************************************
		
		//******************crea las series de tiempo************************
		//********************************************************************
		
		////////////lineas referencia "ejes"///////////////
		
		ejeX[0][0] = 0.0;
		ejeX[0][1] = numero;
		ejeX[0][2] = 0.0;

		ejeX[1][0] = xmax;
		ejeX[1][1] = numero;
		ejeX[1][2] = 0.0;
		
		SoSeparator *referenciaX = new SoSeparator;
		referenciaX->ref();
		SoCoordinate3 * xCoords = new SoCoordinate3;		
		xCoords->point.setValues(0, 2, ejeX);
		referenciaX->addChild(xCoords);
		referenciaX->addChild(new SoLineSet);
		selection->addChild(referenciaX);
		
		/////////////////////////////////////////////////////////////////////////////////////////////
		ejeY[0][0] = 0.0;
		ejeY[0][1] = float(-ymax-.001);
		ejeY[0][2] = 0.0;
		
		ejeY[1][0] = 0.0;
		ejeY[1][1] = numero;
		ejeY[1][2] = 0.0;
		
		SoSeparator *referenciaY = new SoSeparator;
		referenciaY->ref();
		SoCoordinate3 * yCoords = new SoCoordinate3;		
		yCoords->point.setValues(0, 2, ejeY);
		referenciaY->addChild(yCoords);
		referenciaY->addChild(new SoLineSet);
		selection->addChild(referenciaY);

		////////////fin lineas referencia "ejes"///////////////


		//********************Linea verde************************************
		// primero creas el separador para contener toda la estructura a graficar
		lineaVerde = new SoSeparator;
		lineaVerde->unref();
		// despues creas y llenas los contenedores de datos
		coordsLVerdeA = new SoCoordinate3;
		coordsLVerdeB = new SoCoordinate3;
		for(int i=0; i<NUMPOINTS; ++i){
			serieVerde[i][0] = (float(i)/float(NUMPOINTS))*xmax;
			serieVerde[i][1] = numero;
			serieVerde[i][2] = 0.0;
		}
		coordsLVerdeA->point.setValues(0, NUMPOINTS, serieVerde);
		coordsLVerdeA->unref();
		coordsLVerdeB->point.setValues(0, NUMPOINTS, serieVerde);
		coordsLVerdeB->unref();
		SoBaseColor * colVerde = new SoBaseColor;
		colVerde->rgb = SbColor(0, 1, 0);
		lineaVerde->addChild(colVerde);
		lineaVerde->addChild(coordsLVerdeA);
		lineaVerde->addChild(new SoLineSet);
		selection->addChild(lineaVerde);
		
		//********************fin Linea verde************************************
		
		//********************Linea cafe************************************
		// primero creas el separador para contener toda la estructura a graficar
		lineaCafe = new SoSeparator;
		lineaCafe->unref();
		// despues creas y llenas los contenedores de datos
		coordsLCafeA = new SoCoordinate3;
		coordsLCafeB = new SoCoordinate3;
		for(int i=0; i<NUMPOINTS; ++i){
			serieCafe[i][0] = (float(i)/float(NUMPOINTS))*xmax;
			serieCafe[i][1] = numero;
			serieCafe[i][2] = 0.0;
		}
		coordsLCafeA->point.setValues(0, NUMPOINTS, serieCafe);
		coordsLCafeA->unref();
		coordsLCafeB->point.setValues(0, NUMPOINTS, serieCafe);
		coordsLCafeB->unref();
		SoBaseColor * colCafe = new SoBaseColor;
		colCafe->rgb = SbColor(.8, .5, 0);
		lineaCafe->addChild(colCafe);
		lineaCafe->addChild(coordsLCafeA);
		lineaCafe->addChild(new SoLineSet);
		selection->addChild(lineaCafe);
		
		//********************fin Linea cafe************************************

		//********************Linea Dominante************************************
		// primero creas el separador para contener toda la estructura a graficar
		lineaDominante = new SoSeparator;
		lineaDominante->unref();
		// despues creas y llenas los contenedores de datos
		coordsDominanteA = new SoCoordinate3;
		coordsDominanteB = new SoCoordinate3;
		for(int i=0; i<NUMPOINTS; ++i){
			serieDominante[i][0] = (float(i)/float(NUMPOINTS))*xmax;
			serieDominante[i][1] = numero;
			serieDominante[i][2] = 0.0;
		}
		coordsDominanteA->point.setValues(0, NUMPOINTS, serieDominante);
		coordsDominanteA->unref();
		coordsDominanteB->point.setValues(0, NUMPOINTS, serieDominante);
		coordsDominanteB->unref();
		SoBaseColor * colDominante = new SoBaseColor;
		colDominante->rgb = SbColor(1, 0, 0);
		lineaDominante->addChild(colDominante);
		lineaDominante->addChild(coordsDominanteA);
		lineaDominante->addChild(new SoLineSet);
		selection->addChild(lineaDominante);
		
		//********************fin Linea Dominante************************************

		//********************Linea Recesivo************************************
		// primero creas el separador para contener toda la estructura a graficar
		lineaRecesivo = new SoSeparator;
		lineaRecesivo->unref();
		// despues creas y llenas los contenedores de datos
		coordsRecesivoA = new SoCoordinate3;
		coordsRecesivoB = new SoCoordinate3;
		for(int i=0; i<NUMPOINTS; ++i){
			serieRecesivo[i][0] = (float(i)/float(NUMPOINTS))*xmax;
			serieRecesivo[i][1] = numero;
			serieRecesivo[i][2] = 0.0;
		}
		coordsRecesivoA->point.setValues(0, NUMPOINTS, serieRecesivo);
		coordsRecesivoA->unref();
		coordsRecesivoB->point.setValues(0, NUMPOINTS, serieRecesivo);
		coordsRecesivoB->unref();
		lineaRecesivo->addChild(coordsRecesivoA);
		lineaRecesivo->addChild(new SoLineSet);
		selection->addChild(lineaRecesivo);
		
		//********************fin Linea Recesivo************************************

		//***********************************************************************
		//******************fin crea las series de tiempo************************
	
		return selection;
	}

	static LRESULT CALLBACK eventHandler(HWND window, UINT message, WPARAM wparam, LPARAM lparam)
{
        // If we send ourselves the close message, then actually close the window.
        // If a user clicks close, ignore it.
        View* i = (View*) wparam;
        switch (message)
        {
        case WM_CLOSE :
                // The window is already hidden; refuse the request to terminate.
                // Do that when the dll is freed.
			SoWin::exitMainLoop();
			salir = true;
                return 0;
//                return CallWindowProc(oldEventHandler, window, message, wparam, lparam);

        // Process a DLL close message
        case WM_USER :
                return CallWindowProc(oldEventHandler, window, WM_CLOSE, wparam, lparam);

        // Process updates sent from the other thread
        case WM_USER + 1:
                i->doUpdates();
                return 0;

        case WM_USER + 3:
                SoWin::hide(i->mainWindow);
                i->freeRoot();
                return 0;
		case WM_COMMAND:
			if (HIWORD(wparam) == BN_CLICKED) 
                { 
                    switch (LOWORD(wparam)) 
                    { 
                        case PLAY:
							corre = true;
							lcafe = false;
							lverde = false;
							gato = false;

							return 0;
						case STOP: 
							corre = false;
							return 0;
						case LIMPIA: 
							if(!corre){
								limpiaTodo();
								i->doUpdates();
								// actualiza los valores de la serie
								iteracion = 0;
								for(int i=0; i<NUMPOINTS; ++i){
									serieCafe[i][0] = (float(i)/float(NUMPOINTS))*xmax;
									serieCafe[i][1] = numero;
					
									serieVerde[i][0] = (float(i)/float(NUMPOINTS))*xmax;
									serieVerde[i][1] = numero;

									serieRecesivo[i][0] = (float(i)/float(NUMPOINTS))*xmax;
									serieRecesivo[i][1] = numero;

									serieDominante[i][0] = (float(i)/float(NUMPOINTS))*xmax;
									serieDominante[i][1] = numero;
								}
								i->doUpdates();
							}
							return 0;
						case LLENA:
							if(!corre){
								init();
								// actualiza los valores de la serie
								iteracion = 0;
								for(int i=0; i<NUMPOINTS; ++i){
									serieCafe[i][0] = (float(i)/float(NUMPOINTS))*xmax;
									serieCafe[i][1] = numero;
					
									serieVerde[i][0] = (float(i)/float(NUMPOINTS))*xmax;
									serieVerde[i][1] = numero;

									serieRecesivo[i][0] = (float(i)/float(NUMPOINTS))*xmax;
									serieRecesivo[i][1] = numero;

									serieDominante[i][0] = (float(i)/float(NUMPOINTS))*xmax;
									serieDominante[i][1] = numero;
								}
								i->doUpdates();
							}
							return 0;
						case VERDE:
							if(!corre){
								verde =  1.0;
								azul  =  .0;
								rojo = .0;
								col->rgb = SbColor(rojo, verde, azul);
								seleccionContra = 1;
							}
							return 0;
						case CAFE:
							if(!corre){
								verde =  .55;
								azul  =  .0;
								rojo = .99;
								col->rgb = SbColor(rojo, verde, azul);
								seleccionContra = 2;
							}
							return 0;
						case BLANCO:
							if(!corre){
								verde =  .99;
								azul  =  .99;
								rojo = .99;
								col->rgb = SbColor(rojo, verde, azul);
								seleccionContra = 0;
							}
							return 0;
						case GENDOMINANTE:
							if(!corre){
								if(dominante == 1){
									dominante = 2;
									resesivo = 1;
									//coloca al boton la imagen
									SendMessage(botonGenDominante,(UINT) BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)genDominante2);
								}
								else{
									dominante = 1;
									resesivo = 2;
									//coloca al boton la imagen
									SendMessage(botonGenDominante,(UINT) BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)genDominante1);
								}
								// actualiza los valores de la serie
								for(int i=0; i<NUMPOINTS; ++i){
									serieRecesivo[i][0] = (float(i)/float(NUMPOINTS))*xmax;
									serieRecesivo[i][1] = numero;

									serieDominante[i][0] = (float(i)/float(NUMPOINTS))*xmax;
									serieDominante[i][1] = numero;
								}
								i->doUpdates();
							}
							return 0;
						case LCAFE:
							if(!corre){
								lcafe = true;
								lverde = false;
								gato = false;
							}
							return 0;
						case LVERDE:
							if(!corre){
								lcafe = false;
								lverde = true;
								gato = false;
							}
							return 0;
						case GATO:
							if(!corre){
								lcafe = false;
								lverde = false;
								gato = true;
							}
							return 0;
					}
			}
			
				return 0;
        
        // Process all other Windows messages
        default :
                return CallWindowProc(oldEventHandler, window, message, wparam, lparam);
        }
}



public: 
	bool soRendering;
	
	
	void ThreadCtor(){
		
		printf("view creada\n");
		
		printf("vista valore de corre = %d\n", corre);
		printf("vista  valore de &corre = %d\n", &corre);
	}
	~View(){}
	
	virtual DWORD Run( LPVOID arg ){
		//printf("el valor del puntero de corre = %d", &val->corre);
		// mientras no quieras salir de la alpicacion
		 mainWindow = SoWin::init("trunkVrml", "trunkClass");
        if (mainWindow == NULL)
                return 1;

        //------------------- Install my own WM_CLOSE handler-------------------------------------

        HWND tmp = SoWin::getTopLevelWidget();	
		
		/****************************************************************************
		* The GetWindowLong function retrieves information about the specified window.
		* SoWin::getTopLevelWidget()  == Handle to the window and, indirectly, the class 
		* to which the window belongs. 
        * GWL_WNDPROC  === 
		* en este caso Retrieves the address of the window procedure, or a handle 
		* representing the address of the window procedure. You must use the CallWindowProc 
		* function to call the window procedure.
		*
		*este valor se usa para llamar al event handler windowsero dentro del nuevo
		*******************************************************************************/
		oldEventHandler = (WNDPROC) GetWindowLong(SoWin::getTopLevelWidget(), GWL_WNDPROC);
		/***************************************************************************
		* The SetWindowLong function changes an attribute of the specified window. The 
		* function also sets the 32-bit (long) value at the specified offset into the 
		* extra window memory.
		* SoWin::getTopLevelWidget() =====
		* Handle to the window and, indirectly, the class to which the window belongs
		* GWL_WNDPROC ==
		* Sets a new address for the window procedure
		* eventHandler == 
		* Specifies the replacement value.
		* con esto ya creaste el nuevo event handler y se maneja dentro de la funcion
		* eventHandler
		*/
		SetWindowLong(SoWin::getTopLevelWidget(), GWL_WNDPROC, (long) eventHandler);
		//-------------------fin -- Install my own WM_CLOSE handler------------------------------

        viewer = new SoWinExaminerViewer(mainWindow);
		creaBotones();
		viewer->setPopupMenuEnabled(false);
		viewer->setSceneGraph(createRoot());
		viewer->show();

		SoIdleSensor* idle = new SoIdleSensor(myFunc, this);
		idle->schedule();

		SoWin::show(mainWindow);
		viewer->setTransparencyType(SoGLRenderAction::SORTED_OBJECT_BLEND);
		SoWin::show(mainWindow);
		SoWin::mainLoop();
		return 0;
	}
	void freeRoot()
	{
        // Deallocate the root node and everything under it
		root->unref();
        root = NULL;
	}
	void doUpdates()
	{
		printf("  -- principio doUpdates --\n");
		
		int flag = 0;
		for(int i =0; i< xmax;++i)
			for(int j = 0; j < ymax; ++j){
				flag =0;
				if(statesMatrix[i][j].type == 0){
					if(copiaStatesMatrix[i][j] != 0){
						grid[i][j]->replaceChild(grid[i][j]->textura,texturas[0]);
						grid[i][j]->setTexture(texturas[0]);
						//iguala la matriz de estados con la guardada
						copiaStatesMatrix[i][j] = 0;
					}
					goto finImagen;
				}
				else if(statesMatrix[i][j].type == 1)
				{
					if(statesMatrix[i][j].juvenil == true){
						if(copiaStatesMatrix[i][j] != 1){
							grid[i][j]->replaceChild(grid[i][j]->textura,texturas[1]);
							grid[i][j]->setTexture(texturas[1]);
							copiaStatesMatrix[i][j] = 1;
						}
						goto finImagen;
					}
					else{
						if(statesMatrix[i][j].derecho == true)
							flag = 2;
						else
							flag = 10;
					}//else
				}//else if
				else if(statesMatrix[i][j].type == 2)
				{
					if(statesMatrix[i][j].juvenil == true){
						if(copiaStatesMatrix[i][j] != 18){
							grid[i][j]->replaceChild(grid[i][j]->textura,texturas[18]);
							grid[i][j]->setTexture(texturas[18]);
							copiaStatesMatrix[i][j] = 18;
						}
						goto finImagen;
					}
					else{
						if(statesMatrix[i][j].derecho == true)
							flag = 19;
						else
							flag = 27;
					}//else
				}//else if
				else if(statesMatrix[i][j].type == 3)
				{
					if(statesMatrix[i][j].comiendo == true){
						if(statesMatrix[i][j].lagartijaVerde == true){
							if(copiaStatesMatrix[i][j] != 52){
							grid[i][j]->replaceChild(grid[i][j]->textura,texturas[52]);
							grid[i][j]->setTexture(texturas[52]);
							copiaStatesMatrix[i][j] = 52;
							}
						}
						else{
							if(copiaStatesMatrix[i][j] != 51){
							grid[i][j]->replaceChild(grid[i][j]->textura,texturas[51]);
							grid[i][j]->setTexture(texturas[51]);
							copiaStatesMatrix[i][j] = 51;
							}
						}
						goto finImagen;
					}
					else{
						if(statesMatrix[i][j].derecho == true)
							flag = 35;
						else
							flag = 43;
					}//else
				}//else if
				switch(statesMatrix[i][j].direccion) {
					case 1 : 
						if(copiaStatesMatrix[i][j] != flag){
							grid[i][j]->replaceChild(grid[i][j]->textura,texturas[flag]);
							grid[i][j]->setTexture(texturas[flag]);
							copiaStatesMatrix[i][j] = flag;
						}
						break;
					case 2 : 
						if(copiaStatesMatrix[i][j] != flag+1){
							grid[i][j]->replaceChild(grid[i][j]->textura,texturas[flag+1]);
							grid[i][j]->setTexture(texturas[flag+1]);
							copiaStatesMatrix[i][j] = flag+1;
						}
						break;
					case 3 : 
						if(copiaStatesMatrix[i][j] != flag+2){
							grid[i][j]->replaceChild(grid[i][j]->textura,texturas[flag+2]);
							grid[i][j]->setTexture(texturas[flag+2]);
							copiaStatesMatrix[i][j] = flag+2;
						}
						break;
					case 4 : 
						if(copiaStatesMatrix[i][j] != flag+3){
							grid[i][j]->replaceChild(grid[i][j]->textura,texturas[flag+3]);
							grid[i][j]->setTexture(texturas[flag+3]);
							copiaStatesMatrix[i][j] = flag+3;
						}
						break;
					case 5 : 
						if(copiaStatesMatrix[i][j] != flag+4){
							grid[i][j]->replaceChild(grid[i][j]->textura,texturas[flag+4]);
							grid[i][j]->setTexture(texturas[flag+4]);
							copiaStatesMatrix[i][j] = flag+4;
						}
						break;
					case 6 : 
						if(copiaStatesMatrix[i][j] != flag+5){
							grid[i][j]->replaceChild(grid[i][j]->textura,texturas[flag+5]);
							grid[i][j]->setTexture(texturas[flag+5]);
							copiaStatesMatrix[i][j] = flag+5;
						}
						break;
					case 7 : 
						if(copiaStatesMatrix[i][j] != flag+6){
							grid[i][j]->replaceChild(grid[i][j]->textura,texturas[flag+6]);
							grid[i][j]->setTexture(texturas[flag+6]);
							copiaStatesMatrix[i][j] = flag+6;
						}
						break;
					default:
						if(copiaStatesMatrix[i][j] != flag+7){ 
							grid[i][j]->replaceChild(grid[i][j]->textura,texturas[flag+7]);									grid[i][j]->setTexture(texturas[flag+7]);
							copiaStatesMatrix[i][j] = flag+7;
						}					
				} //end switch
				finImagen:
					;
			}//for j

			//calcula las cantidades de cada tipo
			calculaCantidades();
			
			// primero actualiza los valores de la serie
			if(iteracion == NUMPOINTS){
				iteracion = 0;
				for(int i=0; i<NUMPOINTS; ++i){
					serieCafe[i][0] = (float(i)/float(NUMPOINTS))*xmax;
					serieCafe[i][1] = numero;
					
					serieVerde[i][0] = (float(i)/float(NUMPOINTS))*xmax;
					serieVerde[i][1] = numero;

					serieRecesivo[i][0] = (float(i)/float(NUMPOINTS))*xmax;
					serieRecesivo[i][1] = numero;

					serieDominante[i][0] = (float(i)/float(NUMPOINTS))*xmax;
					serieDominante[i][1] = numero;
					
				}

			}
			// todo esto es solo para hacer que el fin de la grafica termine recto "paralelo" al eje y 
			if(iteracion != NUMPOINTS-1){
				serieCafe[iteracion+1][0] = (float(iteracion)/float(NUMPOINTS))*xmax;
				serieVerde[iteracion+1][0] = (float(iteracion)/float(NUMPOINTS))*xmax;
				serieDominante[iteracion+1][0] = (float(iteracion)/float(NUMPOINTS))*xmax;
				serieRecesivo[iteracion+1][0] = (float(iteracion)/float(NUMPOINTS))*xmax;
			}			
			serieCafe[iteracion][1] = ((float(lagartijaCafe)/float(xmax*ymax))*diferencia) + numero;
			serieCafe[iteracion][0] = (float(iteracion)/float(NUMPOINTS))*xmax;
				
			serieVerde[iteracion][1] = ((float(lagartijaVerde)/float(xmax*ymax))*diferencia) + numero;
			serieVerde[iteracion][0] = (float(iteracion)/float(NUMPOINTS))*xmax;
				
			serieDominante[iteracion][1] = ((float(aleloDominante)/(float(xmax*ymax)*2))*diferencia) + numero;
			serieDominante[iteracion][0] = (float(iteracion)/float(NUMPOINTS))*xmax;
				
			serieRecesivo[iteracion][1] = ((float(aleloRecesivo)/(float(xmax*ymax)*2))*diferencia) + numero;
			serieRecesivo[iteracion][0] = (float(iteracion)/float(NUMPOINTS))*xmax;
				
			printf("serieCafe = %f, serieVerde = %f\n",serieCafe[iteracion][1] , serieVerde[iteracion][1]);
			printf("serieCafe = %f, serieVerde = %f\n",serieCafe[iteracion][0] , serieVerde[iteracion][0]);
				
			// depues actualiza los dibujos de las lineas
			if(banderita){
				coordsLCafeB->point.setValues(0, NUMPOINTS, serieCafe);
				lineaCafe->replaceChild(coordsLCafeA, coordsLCafeB);
				
				coordsLVerdeB->point.setValues(0, NUMPOINTS, serieVerde);
				lineaVerde->replaceChild(coordsLVerdeA, coordsLVerdeB);
				
				coordsDominanteB->point.setValues(0, NUMPOINTS, serieDominante);
				lineaDominante->replaceChild(coordsDominanteA, coordsDominanteB);

				coordsRecesivoB->point.setValues(0, NUMPOINTS, serieRecesivo);
				lineaRecesivo->replaceChild(coordsRecesivoA, coordsRecesivoB);

				banderita = false;
			}
			else{
				coordsLCafeA->point.setValues(0, NUMPOINTS, serieCafe);
				lineaCafe->replaceChild(coordsLCafeB, coordsLCafeA);
				
				coordsLVerdeA->point.setValues(0, NUMPOINTS, serieVerde);
				lineaVerde->replaceChild(coordsLVerdeB, coordsLVerdeA);
				
				coordsDominanteA->point.setValues(0, NUMPOINTS, serieDominante);
				lineaDominante->replaceChild(coordsDominanteB, coordsDominanteA);

				coordsRecesivoA->point.setValues(0, NUMPOINTS, serieRecesivo);
				lineaRecesivo->replaceChild(coordsRecesivoB, coordsRecesivoA);

				banderita = true;
			}


		///////////////////DEBUG//////////////////////////
		/*for(int i = 0; i<xmax;++i){
		for(int j = 0; j<ymax;++j){
			printf("[%d][%d] = %d, ", i, j, statesMatrix[i][j].type);
		}printf("\n");}*/
		///////////////////////DEBUG////////////////////////

		printf("  -- fin       doUpdates --\n");
			
	}// FIN DO UPDATES

	// Notify the Open Inventor thread that updates are ready
    BOOL postUpdates()    { return postUserMessage(1); };
    LRESULT sendUpdates() { return sendUserMessage(1); };
	void term()
{
        // Wait for the scene to close down
        sendUserMessage(3);
}
};
#endif //View_H